<?php
/* Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


function print_backup_status($id)
{
  require_once ("helpers/cmon_db_connect.php");
  $dbh = connect();
 
  $result=mysql_query("SELECT b1.backupid,b1.report_ts as backup_start_time, b2.report_ts-b1.report_ts as backup_time_sec, b.start_gci, b.stop_gci, b.report_ts as backup_completed_time, b.status, b.bytes, b.log_bytes FROM backup b, backup_log b1, backup_log b2  where b.status='BackupCompleted' and  b1.backupid=b2.backupid and b2.backupid=b.backupid and b1.status='BackupStarted' and b2.status<>'BackupStarted' and b1.cid=b2.cid and b1.cid=$id order by b.report_ts desc limit 1 ");
  if (!$result) {
    die('Invalid query: ' . mysql_error());
    mysql_close($dbh);
  }
  $status="";
  while($row = mysql_fetch_array( $result )) 
    {
      $status="<b>Started at:</b> " . $row["backup_start_time"] . "<br>";
      $status= $status . "<b>Completed at:</b> " . $row["backup_completed_time"] . "<br>";
      $status =$status . "<b>Backup id:</b> <a href=\"backup.php?id=" . $id . "&backupid=" . $row["backupid"] . "\">". $row["backupid"] ."</a><br>";
      $status =$status . "<b>Backup start GCI:</b> " . $row["start_gci"] . "<br>";    
      $status =$status . "<b>Backup stop GCI:</b> " . $row["stop_gci"] . "<br>";
      $status =$status . "<b>Backup data is </b> " . round($row["bytes"]/1024/1024,2) . " MB and the log ". round($row["log_bytes"]/1024/1024,2) .  
	" MB and was backed up in " . $row["backup_time_sec"] .  " seconds.<br>";
      
    }
  if($status=="")
    print("No backup has been taken");  
  else
    print($status);  
  mysql_close($dbh); 
}



function printBackupLog()
{
  require_once ("helpers/cmon_db_connect.php");
  $dbh = connect();  
  
  $result = mysql_query("SELECT * FROM backup_log order by report_ts desc limit 50");
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  
  print("<table class=\"small\">\n");
  print("<tr class=\"hed\">\n");
  print("<td class=\"hed\">\n");
  print("backup id");
  print("</td>\n");
  print("<td class=\"hed\">\n");
  print("status");
  print("</td>\n");
  print("<td class=\"hed\">\n");
  print("error");
  print("</td>\n");
  print("<td class=\"hed\">\n");
  print("reported");
  print("</td>\n");
  print("</tr>\n");

  while($row = mysql_fetch_array( $result )) 
    {
      print("<tr class=\"hed\">\n");
      print("<td>" . $row["backupid"]  . "</td>");
      if(strcmp($row["status"],"BackupCompleted")==0)
      	print("<td><a href=\"backupdetails.php?backupid=" . $row["backupid"]  . "\">" . $row["status"]  . "</a></td>");
      else
      	print("<td>" . $row["status"]  . "</td>");
      print("<td>" . $row["error"]  . "</td>");
      print("<td>" . $row["report_ts"]  . "</td>");
      print("</tr>\n");
    }
  print("</table>\n");
  mysql_close($dbh);
}

function print_backup_html($id, $backupid)
{
	if($id==0)
        {
	     print("<h2>Viewing the cluster log - please select a cluster first</h2>\n");  
	     die("");
       }

    $backups= get_backup_records ($id);
    $name=get_cluster_name($id);
    if ($name=="")
      $name=$id;
    print("<h2>Viewing backups taken from Cluster '$name'</h2>\n");  

    print("<div class=\"detail-box2\">\n");
    print("<table class=\"small\">");
    print("<tr class=\"hed\">\n");
    print("<td class=\"hed\">\n");
    print("backupid");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("status");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("backup time");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("start gci");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("stop gci");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("records");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("log records");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("bytes");
    print("</td>\n");
    print("<td class=\"hed\">\n");
    print("log bytes");
    print("</td>\n");
    print("</tr>\n");
    foreach ($backups as &$b)
     { 
    print("<tr>\n");
    print("<td>\n");
    print($b["backupid"]);
    print("</td>\n");
    if($b["status"]=="BackupCompleted")
       print("<td class=\"green\">\n");    
    else
       print("<td class=\"red\">\n");    
    print($b["status"]);
    print("</td>\n");
    print("<td>\n");
    print($b["report_ts"]);
    print("</td>\n");
    print("<td>\n");
    print($b["start_gci"]);
    print("</td>\n");
    print("<td>\n");
    print($b["stop_gci"]);
    print("</td>\n");
    print("<td>\n");
    print($b["records"]);
    print("</td>\n");
    print("<td>\n");
    print($b["log_records"]);
    print("</td>\n");
    print("<td>\n");
    print($b["bytes"]);
    print("</td>\n");
    print("<td>\n");
    print($b["log_bytes"]);
    print("</td>\n");
    print("</tr>\n");
      }
    print("</table>\n");
  print("<br clear=\"all\"/>\n");
  print("</div>\n");
    

}

function get_backup_records ($cid)
{
  require_once ("helpers/cmon_db_connect.php");

  $dbh = connect();  
  $query="SELECT backupid,report_ts,status,start_gci,stop_gci,records,log_records,bytes,log_bytes FROM backup WHERE cid=" . $cid . " order by report_ts desc";

  $result = mysql_query($query);
  
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  $backup_arr=array();
  $i=0;
  while($row = mysql_fetch_array( $result )) 
  {
        $backup_arr[$i]=array();
	$backup_arr[$i]["backupid"]=$row["backupid"];
	$backup_arr[$i]["start_gci"]=$row["start_gci"];
	$backup_arr[$i]["stop_gci"]=$row["stop_gci"];
	$backup_arr[$i]["status"]=$row["status"];
	$backup_arr[$i]["log_records"]=$row["log_records"];
	$backup_arr[$i]["records"]=$row["records"];
	$backup_arr[$i]["bytes"]=$row["bytes"];
	$backup_arr[$i]["log_bytes"]=$row["log_bytes"];
	$backup_arr[$i]["report_ts"]=$row["report_ts"];
        $i++;
  } 
 mysql_close($dbh);
  return $backup_arr;
}






function printRestore ()
{
  require_once ("helpers/cmon_db_connect.php");
  $dbh = connect();  

  $result = mysql_query("SELECT backupid FROM restore order by report_ts desc limit 1");  
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  $backupid=0;
  while($row = mysql_fetch_array( $result )) 
    {	     
      $backupid=$row["backupid"];
    }   

  if($backupid==0)
    {
      printf("nothing has been restored yet");
      mysql_close($dbh);
      return;
    }
  

  $result = mysql_query("SELECT nodeid  FROM node_state WHERE node_type='NDBD'");  
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  

  $cluster=array();
  while($row = mysql_fetch_array( $result )) 
    {	     
      $cluster[]=$row["nodeid"];
    }   

  $result = mysql_query("SELECT * FROM restore WHERE backupid=" . $backupid);
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }

  print("<table class=\"small\">\n");
  $n_recs=0;
  $n_logrecs=0;
  $n_bytes=0;
  $n_logbytes=0; 
  $n_tables=0; 
  $n_tablespaces=0;    
  $n_logfilegroups=0;    
  $n_datafiles=0;    
  $n_undofiles=0;    
  $nodes=array();
  $ts="";
  while($row = mysql_fetch_array( $result )) 
    {	     
      $n_recs += $row["records"];
      $n_logrecs += $row["log_records"];
      $n_bytes += $row["bytes"];
      $n_logbytes += $row["log_bytes"];
      $n_tables =$row["n_tables"] ;
      $n_tablespaces =$row["n_tablespaces"];	
      $n_logfilegroups =$row["n_logfilegroups"];	
      $n_datafiles =$row["n_datafiles"];	
      $n_undofiles=$row["n_undofiles"];	
      $nodes[]=$row["ndb_nodeid"];
      $ts=$row["report_ts"] ;
    } 
  print("<tr class=\"hed\"><td class=\"hed\">backupid</td><td><a href=\"backupdetails.php?backupid=" . $backupid  . "\">" . $backupid .  "</a></td></tr>\n");
  //      print("<tr class=\"hed\"><td class=\"hed\">status</td><td>" . $row["status"]  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">data records</td><td>" . $n_recs  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">log records</td><td>" . $n_logrecs  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">data backup size (MB)</td><td>" . round($n_bytes/1024/1024,2)  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">log backup size (MB)</td><td>" . round($n_logbytes/1024/1024,2)  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">total backup size (MB)</td><td>" . round( ($n_bytes + $n_logbytes)/1024/1024,2)  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">no of tables</td><td>" . $n_tables . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">no of tablespaces</td><td>" . $n_tablespaces  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">no of log file groups</td><td>" . $n_logfilegroups  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">no of data files</td><td>" . $n_datafiles  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">no of undo files</td><td>" . $n_undofiles  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">all data nodes (ids)</td><td>" . implode(",",$cluster)  . "</td></tr>\n");
  print("<tr class=\"hed\"><td class=\"hed\">restored data nodes (ids)</td><td>" . implode(",",$nodes)  . "</td></tr>\n");
  sort($cluster);
  sort($nodes);
  if((strcmp(implode(",", $cluster ),implode(",", $nodes ))!=0))
    {	
      print("<tr class=\"hed\"><td class=\"hed\">Status</td><td class=\"red\">Incomplete Restore</td></tr>\n");
    }
  else
    {
      print("<tr class=\"hed\"><td class=\"hed\">Status</td><td>Complete</td></tr>\n");
      print("<tr class=\"hed\"><td class=\"hed\">completed at</td><td>" . $ts . "</td></tr>\n");
    }

  print("</table>\n");
  mysql_close($dbh);
}
?>
