<?php
	/* Copyright (C) 2008 severalnines.com                                                                                
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or  
	 (at your option) any later version. 
	 This program is distributed in the hope that it will be useful,  
	 but WITHOUT ANY WARRANTY; without even the implied warranty of 
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.
	 You should have received a copy of the GNU General Public License 
	 along with this program; if not, write to the Free Software
	 
	 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
	
	
	$dbh="";
	
	function print_ndbd_status($id, $action, $selected)
	{
		
		$data_nodes_arr=get_ndb_record($id);
		print("<table class=\"smallblack\">\n");
		print("<tr class=\"hed\">\n");
		print("<td class=\"hed\">\n");
		print("nodeid");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("hostname");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("node group");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("status");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("version");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("last reported");
		print("</td>\n");
		if($action=="manage")
		{
			/*
			 print("<td class=\"hed\">\n");
			 print("manage");
			 print("</td>\n");
			 */
		}
		print("<td class=\"hed\">\n");
		print("details");
		print("</td>\n");
		
		print("</tr>\n");
		$i=0;
		foreach ($data_nodes_arr as &$ndbd)
		{ 
			$c="";
			if($i %2 ==0)
				$c="\"even\"";
			else
				$c="\"odd\"";
			$hname=$ndbd["host"];
			$nodeid=$ndbd["nodeid"];
			$nodestatus=$ndbd["status"];
			$report_ts=$ndbd["report_ts"];	      
			$report_warning=$ndbd["report_warning"];	      
			$version=$ndbd["version"];	      
			$nodegroup=$ndbd["nodegroup"];		
			$select=0;
			if($selected==$nodeid)
			{
				print("<tr>");
				$c="\"selected\"";
				$select=1;
			}
			else
				print("<tr >");
			$status="<td class=$c>". $nodeid. "</td><td class=$c>". $hname . "</td><td class=$c>" . $nodegroup. "</td>";
			
			if($report_warning)
			{
				if($select)
					$status = $status . "<td class=\"yellowselected\">" ."UNKNOWN" . "</td>";
				else
					if($i %2 ==0)
						$status = $status . "<td class=\"yellow\">" . "UNKNOWN" . "</td>";
					else
						$status = $status . "<td class=\"yellowodd\">" . "UNKNOWN" . "</td>";
			}
			else
			{
				if(is_started($nodestatus))
				{
					if($select)
						$status = $status . "<td class=\"greenselected\">" . $nodestatus . "</td>";
					else
						if($i %2 ==0)
							$status = $status . "<td class=\"green\">" . $nodestatus . "</td>";
						else
							$status = $status . "<td class=\"greenodd\">" . $nodestatus . "</td>";
				}
				else if(is_no_contact($nodestatus))
				{
					if($select)
						$status = $status . "<td class=\"redselected\">" . $nodestatus . "</td>";
					else
						if($i %2 ==0)
							$status = $status . "<td class=\"red\">" . $nodestatus . "</td>";
						else
							$status = $status . "<td class=\"redodd\">" . $nodestatus . "</td>";
					
				}
				else if(is_not_started($nodestatus))
				{
					if($select)
						$status = $status . "<td class=\"redselected\">" . $nodestatus . "</td>";
					else
						if($i %2 ==0)
							$status = $status . "<td class=\"red\">" . $nodestatus . "</td>";
						else
							$status = $status . "<td class=\"redodd\">" . $nodestatus . "</td>";
				}
				else 
				{
					if($select)
						$status = $status . "<td class=\"yellowselected\">" . $nodestatus . "</td>";
					else
						if($i %2 ==0)
							$status = $status . "<td class=\"yellow\">" . $nodestatus . "</td>";
						else
							$status = $status . "<td class=\"yellowodd\">" . $nodestatus . "</td>";
				}
			}
			$status = $status . "<td class=$c>" . $version . "</td>";
			print($status . "<td class=$c>" . $report_ts .   "</td>\n"); 
			
			if($action=="manage")
			{   
				/*
				 print("<td>");
				 if(is_started($nodestatus) &&  is_node_mapped($id,$nodeid))
				 {
				 print("<a href=\"manage.php?action=stop&id=$id&nodeid=$nodeid\" onClick=\"return popup(this,'test')\">stop</a>");
				 print("&nbsp;&nbsp;&nbsp;");
				 print("<a href=\"manage.php?action=restart&id=$id&nodeid=$nodeid\" onClick=\"return popup(this,'test')\">restart</a>");
				 
				 }
				 if(is_no_contact($nodestatus) &&  is_node_mapped($id,$nodeid))
				 {
				 print("<a href=\"manage.php?action=start&id=$id&nodeid=$nodeid\" onClick=\"return popup(this,'test')\">start</a>");
				 }
				 */
				print("</td>");
			}
			print("<td class=$c>");
			if(is_started($nodestatus))
				print("<a href=\"viewnode.php?id=$id&nodeid=$nodeid\">view</a>");
			print("</td>");
			print("</tr>\n"); 
			$i++;
		}
		print("</table>\n");
	}
	
	function is_not_started($nodestatus)
	{
		return (strcmp($nodestatus,"NOT_STARTED") ==0) ? 1: 0;
	}
	
	function is_started($nodestatus)
	{
		return (strcmp($nodestatus,"STARTED") ==0) ? 1: 0;
	}
	
	function is_connected($nodestatus)
	{
		return (strcmp($nodestatus,"CONNECTED") ==0) ? 1: 0;
	}
	
	
	function is_no_contact($nodestatus)
	{
		return (strcmp($nodestatus,"NO_CONTACT") ==0) ? 1: 0;
	}
	
	function is_unknown($nodestatus)
	{
		return (strcmp($nodestatus,"UNKNOWN") ==0) ? 1: 0;
	}
	
	
	function is_starting($nodestatus)
	{
		return (strcmp($nodestatus,"STARTING") ==0) ? 1: 0;
	}
	
	function get_cluster_name($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		
		$result=mysql_query("SELECT name FROM cluster WHERE id=$id");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$name="";
		while($row = mysql_fetch_array( $result )) 
		{
			$name=$row["name"];
		}
		return $name;
	}
	
	function get_node_status($id, $nodeid)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		
		$result=mysql_query("SELECT status FROM node_state WHERE cid=$id AND nodeid=$nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$status="";
		while($row = mysql_fetch_array( $result )) 
		{
			$status=$row["status"];
		}
		return $status;
	}
	
	
	
	function set_cluster_name($id, $name)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		
		$result=mysql_query("UPDATE cluster SET name=\"". mysql_real_escape_string($name) . "\" WHERE id=$id");
		$rows=mysql_affected_rows($dbh);
		
		if($rows<1)
		{
			die("Writing $name to cmon.cluster failed " . mysql_error($dbh));
		}
		mysql_close($dbh);
	}
	
	
	function get_cluster_status($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		
		$result=mysql_query("SELECT status FROM cluster_state WHERE id=$id");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$status="";
		$time="";
		
		while($row = mysql_fetch_array( $result )) 
		{
			$status=$row["status"];
		}
		return $status;   
	}
	
	
	
	function get_cluster_details($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			return 0;
		
		$result=mysql_query("SELECT cluster_state.id, cluster_state.status, cluster_state.report_ts, (now()-cluster_state.report_ts)>60 as report_warning, cluster.name, cluster.scriptsdir FROM cluster, cluster_state WHERE cluster.id=cluster_state.id");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$memory_arr=get_total_memory_util($row["id"]);
			$arr[$i]=array();
			$arr[$i]["status"]=$row["status"];
			$arr[$i]["report_ts"]=$row["report_ts"];
			$arr[$i]["report_warning"]=$row["report_warning"];
			$arr[$i]["id"]=$row["id"];
			$arr[$i]["name"]=$row["name"];
			//      $arr[$i]["scriptsdir"]=$row["scriptsdir"];
			$arr[$i]["dm"]=$memory_arr["dm"];
			$arr[$i]["im"]=$memory_arr["im"];
			$i++;
		}
		return $arr;
	}
	
	
	
	function check_alarms_exists()
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			return 0;
		
		$result=mysql_query("SELECT count(cid) as cnt  FROM alarm");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$arr=array();
		while($row = mysql_fetch_array( $result )) 
		{
			return $row["cnt"];     
		}
		return 0;
	}
	
	function check_alarms_exists_id($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			return 0;
		
		$result=mysql_query("SELECT count(cid) as cnt  FROM alarm WHERE cid=$id");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$arr=array();
		while($row = mysql_fetch_array( $result )) 
		{
			return $row["cnt"];     
		}
		return 0;
	}
	
	
	function get_alarms($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			return 0;
		
		$result=mysql_query("SELECT cid,nodeid,component,alarm_name,alarm_count,alarm_sent,alarm_sent_count,cluster_state,severity,exit_message,description,recommendation,hostname,report_ts, (now()-report_ts)>60 as report_warning FROM alarm WHERE cid=$id order by report_ts asc");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$arr[$i]=array();
			$arr[$i]["cid"]=$row["cid"];
			$arr[$i]["nodeid"]=$row["nodeid"];
			$arr[$i]["component"]=$row["component"];
			$arr[$i]["alarm_name"]=$row["alarm_name"];
			$arr[$i]["alarm_count"]=$row["alarm_count"];
			$arr[$i]["severity"]=$row["severity"];
			$arr[$i]["exit_message"]=$row["exit_message"];
			$arr[$i]["description"]=$row["description"];
			$arr[$i]["recommendation"]=$row["recommendation"];
			$arr[$i]["hostname"]=$row["hostname"];
			$arr[$i]["report_ts"]=$row["report_ts"];
			$arr[$i]["report_warning"]=$row["report_warning"];
			$i++;
		}
		return $arr;
	}
	
	
	function convert_cluster_status($status)
	{
		if($status=="MGMD_NO_CONTACT")
		{
			return "NO CONTACT WITH <br> NDB_MGMD";
		}
		
		if($status=="STARTED")
		{
			return "STARTED";
		}
		if($status=="NOT_STARTED")
		{
			return "NOT STARTED";
		}
		if($status=="DEGRADED")
		{
			return "DEGRADED";
		}     
		if($status=="FAILURE")
		{
			return "FAILURE - NO CONTACT";
		}     
		
		if($status=="STARTING")
		{
			return "STARTING";
		}     
		
		if($status=="SHUTTING_DOWN")
		{
			return "SHUTTING DOWN";
		}     
		
		if($status=="RECOVERING")
		{
			return "RECOVERING";
		}		
		if($status=="UNKNOWN")
		{	
			return "UNKNOWN";
		}
	}
	
	
	function print_dashboard_menu()
	{
		print("<h4>Dashboard</h4>");
		print("<li><a href=\"#updates\">Updates and Information</a></li>\n");
		print("<li><a href=\"#blogs\">Blogs</a></li>\n");
	}
	
	function print_cluster_menu($selected, $action)
	{ 
		if($selected>0)
		{
			$name=get_cluster_name($selected);
			if ($name=="")
				$name=$selected;
			print("<h3>Cluster - $name</h3><br>");        
			print("<hr />");
			print("<h4>Storage Layer</h4>");
			print("<li><a href=\"index.php?id=$selected\">list nodes</a></li>\n");
			print("<li><a href=\"clusterlog.php?id=$selected&offset=0&filter=ALL&event=ALL\">cluster log</a></li>\n");
			print("<li><a href=\"statistics.php?id=$selected&view=cluster\">cluster statistics</a></li>\n");
			print("<li><a href=\"memory.php?id=$selected&view=cluster\">memory usage</a></li>\n");
			print("<li><a href=\"backup.php?id=$selected\">backup</a></li>\n");
			
		}
		else
		{
			// print("<li><a href=\"settings.php\">settings</a></li>\n");
		}
	}
	function print_sql_menu($selected, $nodeid)
	{
		print("<hr />");
		print("<h4>SQL Layer</h4>");
		print("<li><a href=\"viewmysqld.php?id=$selected\">list mysql servers</a></li>\n");
		//print("<li><a href=\"viewnode.php?id=2">list mysql servers</a></li>\n");
		
		print("<li><a href=\"statistics.php?id=$selected&view=mysqld\">mysql statistics (all)</a></li>\n");
		if(has_replication($selected))
			print("<li><a href=\"replication.php?id=$selected\">replication links</a></li>\n");
		if($nodeid>0)
		{
			$record=get_mysql_record($selected, $nodeid);
			if(count($record)>0)
			{
				$host=$record["host"] . "|" . $record["port"] ;
				print("<li><a href=\"statistics.php?id=$selected&nodeid=$nodeid&view=mysqld&host=$host\">mysql statistics (nodeid $nodeid)</a></li>\n");
			}
		}
		
	}
	
	
	function print_cluster_admin_menu($selected)
	{ 
		if($selected>0)
		{
			print("<hr />");
			print("<h4>Administration</h4>");
			print("<li><a href=\"config.php?action=addmysqld&id=$selected\">add mysql</a></li>\n");
			print("<li><a href=\"config.php?action=removemysqld&id=$selected\">remove mysql</a></li>\n");
		}
		else
		{    
			// print("<li><a href=\"settings.php\">settings</a></li>\n");
		}
		print("<li><a href=\"email.php?id=$selected\">email notifications</a></li>\n");
	}
	
	
	function print_node_menu($selected, $nodeid)
	{ 
		if($selected>0)
		{
			$type=get_node_type($selected,$nodeid);
			if($type=="API")
				$type="MySQLD";
			if($type=="NDBD")
			{
				print("<h4>Data node (id=$nodeid)</h4>");
				print("<li><a href=\"statistics.php?id=$selected&view=ndbd&nodeid=$nodeid\">statistics</a></li>\n");
				print("<li><a href=\"memory.php?id=$selected&nodeid=$nodeid&view=node\">memory usage</a></li>\n");  
			}
			if($type=="MySQLD")
			{
				print("<h4>Mysqld (id=$nodeid)</h4>"); 
				$record=get_mysql_record($selected, $nodeid);
				$host=$record["host"] . "|" . $record["port"] ;
				print("<li><a href=\"statistics.php?id=$selected&nodeid=$nodeid&view=mysqld&host=$host\">statistics</a></li>\n");
			}
			
		}
	}
	
	function print_cluster_status($selected, $action)
	{  
		
		$cluster = get_cluster_details($selected);
		
		if($cluster==0)
		{
			
			return 0;
		}
		print("<div class=\"detail-box2\">\n");
		print("<table class=\"small\">\n");
		print("<tr class=\"hed\">\n");
		print("<td class=\"hed\">\n");
		print("cluster id");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("cluster name");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("status");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("memory (dm / im)");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("last reported");
		print("</td>\n");
		//  print("<td class=\"hed\">\n");
		//  print("scripts");
		//  print("</td>\n");
		print("<td class=\"hed\">\n");
		print("actions");
		print("</td>\n");
		print("</tr>\n");
		$i=1;  
		$warning=0;
		$j=0;
		foreach ($cluster as &$c)
		{ 
			if($j%2==0)
				$cl="\"even\"";
			else
				$cl="\"odd\"";
			
			$t=$c["report_ts"];
			$warning=$c["report_warning"];
			$dm=$c["dm"];
			$im=$c["im"];
			$id=$c["id"];    
			//    $scripts=$c["scriptsdir"];
			$name=$c["name"];
			$status=convert_cluster_status($c["status"]);
			if($warning)
				$status="UNKNOWN";
			$alarm=check_alarms_exists_id($id);
			if($alarm)
			{
				if($selected==$id)
				{
					print("<tr class=\"selectedalarm\">\n");
					$cl="\"selectedalarm\"";
				}
				
				else
				{
					print("<tr class=\"alarm\">\n");
					$cl="\"alarm\"";
				}
			}
			else
			{
				if($selected==$id)
				{
					print("<tr class=\"selected\">\n");
					$cl="\"selected\"";
				}
				else
					print("<tr>\n");
			}
			print("<td class=$cl>\n");
			print("$id");
			print("</td>\n");
			print("<td class=$cl>\n");
			if($name=="")
				print("<a href=\"config.php?action=name&id=$id\">name your cluster!</a>"); 
			else
				print("<a href=\"config.php?action=name&id=$id\">$name</a>"); 
			print("</td>\n");
			$light=get_traffic_light($status, $warning);
			if($alarm)
			{
				if($selected==$id)       
					print("<td class=\"$light" . "selectedalarm".  "\">\n");    
				else
					print("<td class=\"$light" . "alarm".  "\">\n");    
				
			}
			else
			{
				if($selected==$id)       
					print("<td class=\"$light" . "selected".  "\">\n");    
				else
					print("<td class=\"$light\">\n");    
			}
			print($status);
			print("</td>\n");
			$light=get_traffic_light_memory($dm);
			//  print("<td class=\"$light\">\n");    
			print("<td class=$cl>\n"); 
			$dmstr=get_memory_html($light,$dm);
			print($dmstr);
			print("<b> /</b> ");
			$imstr=get_memory_html($light,$im);
			print($imstr);
			print("</td>\n");
			print("<td class=$cl>\n");
			print($t);
			print("</td>\n");
			//    print("<td>\n");
			//    $scr=get_scripts_actions_html($scripts, $id);
			//   print($scr);
			print("</td>\n");
			print("<td class=$cl>\n");
			$actions=get_actions_html($id);
			print($actions);
			print("</td>\n");
			print("</tr>\n");
		}
		print("</table>\n");
		
		foreach ($cluster as &$c)
		{ 
			$name=$c["name"];
			$warning=$c["report_warning"];
			if($warning)
			{
				print("<br><B>Warning! - Cluster '" . $name . "' - cmon has not reported anything to the cmon database within 60 seconds! Please check that CMON is running!</B>");
				print("<br>");
			}
		}
		if($warning)
			print("<br><b>Traffic lights are YELLOW and status is UNKNOWN until problem resolved!</b>");
		
		print("<h2>Pending Alarms</h2><hr>");
		
		if(check_alarms_exists())
		{
			print("<table class=\"small\">\n");
			print("<tr class=\"hed\">\n");
			print("<td class=\"hed\">\n");
			print("cluster name");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("node id");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("component");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("alarm");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("alarm count");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("exit message");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("descriptions");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("recommendation");
			print("</td>\n");
			print("<td class=\"hed\">\n");
			print("updated");
			print("</td>\n");
			print("</tr>\n");
			foreach ($cluster as &$c)
			{  
				$alarms=get_alarms($c["id"]);
				foreach ($alarms as &$a)	
				{   
					print("<tr>\n");
					print("<td>\n");
					if($cname["name"]=="")
						print($c["id"]);
					else
						print($c["name"]);
					print("</td>\n");
					print("<td>\n");
					print($a["nodeid"]);
					print("</td>\n");
					print("<td>\n");
					print($a["component"]);
					print("</td>\n");
					print("<td>\n");
					print($a["alarm_name"]);
					print("</td>\n");
					print("<td>\n");
					print($a["alarm_count"]);
					print("</td>\n");
					print("<td>\n");
					print($a["exit_message"]);
					print("</td>\n");
					print("<td>\n");
					print($a["description"]);
					print("</td>\n");
					print("<td>\n");
					print($a["recommendation"]);
					print("</td>\n");
					print("<td>\n");
					print($a["report_ts"]);
					print("</td>\n");
					print("</tr>\n");
				}
			}  
			print("</table>\n");
			print("<p>Alarms are automatically cleared when problem component is fixed (e.g, a data node has successfully recovered).</p>");
		}  
		else
		{
			print("<p>No pending alarms!</p>");
		}
		print("</div>\n");
		return 1;
	}
	
	
	function get_memory_html($light, $memory)
	{
		if($light=="red")
			return "$memory % <img src=\"img/redball.png\" align=\"absmiddle\"/>\n";
		if($light=="yellow")
			return "$memory % <img src=\"img/yellowball.png\" align=\"absmiddle\"/>\n";
		if($light=="green")
			return "$memory % <img src=\"img/greenball.png\" align=\"absmiddle\"/>\n";
	}
	
	function get_scripts_actions_html($scripts, $id)
	{
		if($scripts=="")
			$actions="<a href=\"config.php?action=config&id=$id\">not configured</a>";
		else
			$actions="<a href=\"config.php?action=update&id=$id\">update</a>";
		return $actions;
	}
	
	function get_actions_html($id)
	{
		$actions="<a href=\"index.php?action=view&id=$id\">view</a>";
		$actions=$actions . "&nbsp;&nbsp;";
		$actions=$actions . "<a href=\"index.php?action=manage&id=$id\">manage</a>";
		return $actions;
	}
	
	function print_ndb_mgmd_status($id, $action)
	{
		print_api_status($id,"NDB_MGMD", $action);
	}
	
	function print_cluster_log_html($id, $offset, $filter, $event)
	{
		
		require_once("helpers/helpers_clusterlog.php");
        require_once ("helpers/bl.php");
		if($id==0)
        {
			print("<h2>Viewing the cluster log - please select a cluster first</h2>\n");  
			die("");
		}
		$name=get_cluster_name($id);
		if ($name=="")
			$name=$id;
		print("<h2>Viewing the cluster log for Cluster '$name'</h2>\n");  
		
		if($filter!='')
			$severity=$filter;
		if($event!='')
			$evt=$event;
		
		$severities=array('ALL', 'DEBUG','INFO', 'WARNING', 'ERROR', 'CRITICAL', 'ALERT');
		$events=array('ALL', 'ArbitResult','ArbitState','CM_REGCONF','CM_REGREF','CommunicationClosed','CommunicationOpened','Connected','ConnectedApiVersion','CopyDict','CopyFragDone','CopyFragsCompleted','CopyFragsStared','Disconnected','FIND_NEIGHBOURS','GCP_TakeoverCompleted','GCP_TakeoverStarted','LCP_TakeoverCompleted','LCP_TakeoverStarted', 'LocalCheckpointStarted', 'LocalCheckpointCompleted','NodeFailCompleted','NODE_FAILREP','StartCompleted','StartPhaseCompleted','StartREDOLog','StopCompleted','StopStarted');
		print("<table>\n");
		print("<fieldset>\n<form action=\"clusterlog.php?offset=$offset\" method=\"get\">\n");		
		
		print("<tr>\n");
		print("<td>\n");				
		print("Severity:\n");		
		print("</td>\n");		
		print("<td>\n");		
		print("<select name=filter>\n");
		foreach ( $severities as &$val)
		{
			if($val==$filter)
				print("<option selected value=\"$val\">$val</option>\n");
			else
				print("<option value=\"$val\">$val</option>\n");
		}
		print("</select>\n");
		print("</td>\n");
		print("<td>\n");				
		print("Event :\n");		
		print("</td>\n");		
		print("<td>\n");			
		print("<select name=event>\n");	
		foreach ( $events as &$val)
		{
			if($val==$event)
				print("<option selected value=\"$val\">$val</option>\n");
			else
				print("<option value=\"$val\">$val</option>\n");
		}
		print("</td>\n");		
		print("<td>\n");		
		print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
		print("<INPUT type=\"submit\" name=\"mysubmit\" value=\"apply filter\">");
		print("</td>\n");		
		print("</tr>\n");		
		
		print("</form>\n</fieldset>\n\n");		
		print("</table>\n");
		
		
		printClusterLog($offset, $filter, $event);
		print("<table class=\"small\"><tr class=\"noborder\">\n");		
		print("<td class=\"noborder\"><a href=\"clusterlog.php?id=$id&offset=0&filter=$severity&event=$evt\">latest 50 entries</a></td>\n");
		if($offset<=50)
			//   print("<td class=\"noborder\"><a href=\"clusterlog.php?id=$id&offset=0&filter=$severity&event=$evt\">later 50 entries</a></td>\n");
			;
		else
		{
			$prev_offset=$offset-50;
			print("<td class=\"noborder\"><a href=\"clusterlog.php?id=$id&offset=$prev_offset&filter=$severity&event=$evt\">later 50 entries</a></td>\n");
		}
		$offset=$offset+50;
		
		print("<td class=\"noborder\"><a href=\"clusterlog.php?id=$id&offset=$offset&filter=$severity&event=$evt\">earlier 50 entries</a></td>\n");
		
		print("</tr></table>");		
		
	}
	
	
	
	function print_cluster_details_html($id, $action)
	{ 
		if ($action!="manage" && $action!="view")
			$action="view";
		
		if($id>0)
		{
			$name=get_cluster_name($id);
			if ($name=="")
			{
				$name=$id;
			}
			if($action=="manage")
			{
				print("<h2>Managing Cluster '$name'</h2>\n");
				//          print("<div class=\"detail-box2\">\n");
				//   print_cluster_actions($id, "manage");
				//        print("</div>\n");
			}
			else
				print("<h2>Viewing Cluster '$name'</h2>\n");
			
			print("<div class=\"detail-box2\">\n");
			print("<a name=\"mgm\"></a><h4>management servers</h4>");
			print_ndb_mgmd_status($id, $action);
			print("</div>\n");
			print("<div class=\"detail-box2\">\n");
			print("<a name=\"ndb\"></a><h4>data nodes</h4>");
			print_ndbd_status($id, $action,"");
			print("</div>\n");
			print("<div class=\"detail-box2\">\n");
			//     if($action=="view")
			//      print_cluster_actions($id, "view");
			print("<a name=\"api\"></a><h4>applications (mysqld, ndbapi, ldap etc)</h4>\n");
			print_api_status($id, "API", $action);
			print("</div>\n");
			print("<div class=\"detail-box2\">\n");
			print("<a name=\"backup\"></a><h4>Backup status of last completed</h4>");
			print_backup_status($id, $action);
			print("</div>\n");
		}	
	}
	
	
	function print_memory_html($id, $nodeid, $view)
	{
		
		require_once("helpers/helpers_clusterlog.php");
        require_once ("helpers/bl.php");
		if($id==0)
        {
			print("<h2>Memory Statistics - please select a cluster first</h2>\n");  
			die("");
		}
		$name=get_cluster_name($id);
		if ($name=="")
			$name=$id;
		
		$graph1d="";
		$graph1m="";
		$graph1w="";
		$graph1y="";
		print("<h2>Memory Statistics for Cluster '$name'</h2>\n"); 
		print("<div class=\"detail-box\">\n");
		if($view=="cluster")
		{     
			
			$graph1d="graphs/cluster_". $id .  "_mem_-1d.png";
			$graph1w="graphs/cluster_". $id .  "_mem_-1w.png";
			$graph1m="graphs/cluster_". $id .  "_mem_-1m.png";
			$graph1y="graphs/cluster_". $id .  "_mem_-1y.png";
		}
		else
		{
            print("<h2>Memory Statistics for NDBD $nodeid <br>(cluster '$name')</h2>\n"); 
			$graph1d="graphs/cluster_". $id .  "_node_".$nodeid ."_mem_-1d.png";
			$graph1w="graphs/cluster_". $id .  "_node_".$nodeid."_mem_-1w.png";
			$graph1m="graphs/cluster_". $id .  "_node_".$nodeid."_mem_-1m.png";
			$graph1y="graphs/cluster_". $id .  "_node_".$nodeid."_mem_-1y.png";
		}
		
		print("<h3>Last 24 hours</h3>\n"); 
		print("<center<img src=\"$graph1d\"/></center>\n");
		
		print("<h3>1 week</h3>\n"); 
		print("<center<img src=\"$graph1w\"/></center>\n");
		
		print("<h3>1 month</h3>\n"); 
		print("<center<img src=\"$graph1m\"/></center>\n");
		
		print("<h3>1 year</h3>\n"); 
		print("<center<img src=\"$graph1y\"/></center>\n");
		print("<br clear=\"all\"/></p>\n");
		print("</div>\n");
	}
	
	
	
	function print_statistics_html($id,  $nodeid, $view, $hostname)
	{
		
		require_once("helpers/helpers_clusterlog.php");
        require_once ("helpers/bl.php");
		if($id==0)
        {
			print("<h2>Statistics - please select a cluster first</h2>\n");  
			die("");
		}
		$name=get_cluster_name($id);
		if ($name=="")
			$name=$id;
		
		$graph1d="";
		$graph1m="";
		$graph1w="";
		$graph1y="";
		print("<h2>Statistics for Cluster '$name'</h2>\n"); 
		print("<div class=\"detail-box\">\n");
		if($view=="cluster")
		{     
			
			$graph1d="graphs/cluster_". $id .  "_stats_-1d.png";
			$graph1w="graphs/cluster_". $id .  "_stats_-1w.png";
			$graph1m="graphs/cluster_". $id .  "_stats_-1m.png";
			$graph1y="graphs/cluster_". $id .  "_stats_-1y.png";
		}
		if($view=="ndbd")
		{
            print("<h2>Statistics for NDBD $nodeid</h2>\n"); 
			$graph1d="graphs/cluster_". $id .  "_node_".$nodeid ."_stats_-1d.png";
			$graph1w="graphs/cluster_". $id .  "_node_".$nodeid."_stats_-1w.png";
			$graph1m="graphs/cluster_". $id .  "_node_".$nodeid."_stats_-1m.png";
			$graph1y="graphs/cluster_". $id .  "_node_".$nodeid."_stats_-1y.png";
		}
		
		if($view=="mysqld"  && $hostname=="")
		{
			
			$mysql_nodes_arr=get_mysql_records($id);
            print("<h2>Statistics aggregated for all mysql servers</h2>\n"); 
			$graph1d="graphs/cluster_". $id .  "_mysql_stats_-1d.png";
			$graph1w="graphs/cluster_". $id .  "_mysql_stats_-1w.png";
			$graph1m="graphs/cluster_". $id .  "_mysql_stats_-1m.png";
			$graph1y="graphs/cluster_". $id .  "_mysql_stats_-1y.png";
			
		}
		if($view=="mysqld"  && $hostname!="")
		{    
            $host=strtok($hostname,"|");
            $port=strtok(NULL);	
            print("<h2>Statistics for mysqld ($host:$port)</h2>\n"); 
       	    $graph1d="graphs/cluster_". $id .  "_mysql_" . $hostname . "_stats_-1d.png";
       	    $graph1w="graphs/cluster_". $id .  "_mysql_" . $hostname . "_stats_-1w.png";
       	    $graph1m="graphs/cluster_". $id .  "_mysql_" . $hostname . "_stats_-1m.png";
       	    $graph1y="graphs/cluster_". $id .  "_mysql_" . $hostname . "_stats_-1y.png";
			
		}
		print("<h3>Last 24 hours</h3>\n"); 
		
		print("<center<img src=\"$graph1d\"/></center>\n");
		
		print("<h3>1 week</h3>\n"); 
		print("<center<img src=\"$graph1w\"/></center>\n");
		
		print("<h3>1 month</h3>\n"); 
		print("<center<img src=\"$graph1m\"/></center>\n");
		
		print("<h3>1 year</h3>\n"); 
		print("<center<img src=\"$graph1y\"/></center>\n");
		print("<br clear=\"all\"/></p>\n");
		print("</div>\n");
		
		
		
	}
	
	
	
	function print_cluster_config_html($id, $action, $submit)
	{ 
		if ($action=="" )
			die("A cluster must first be selected before performing this action.");
		if($id<1)
		{
			die("No cluster selected. Select a Cluster first.");
		}
		$name=get_cluster_name($id);
		if($submit=="")
		{
			if($action=="config")
			{
				print("<div class=\"detail-box\">\n");
				print("<img src=\"img/config.jpg	\" align=\"left\"/>\n");
				print("<h2>Configuring Scripts for  Cluster $id</h2>\n");
				print("<p>You must specify the path to the Configurator package in order to associate the Configurator scripts with the web interface!</p>");
				print_config_scripts_html($id);
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			if($action=="update")
			{
				print("<div class=\"detail-box\">\n");
				print("<img src=\"img/update.png\" align=\"left\"/>\n");
				print("<h2>Update Scripts for Cluster $id</h2>\n");
				print("<p>If you have added mysql servers or data nodes you need to do the update now for scripts to be associated with the web interface!</p>");
				print_config_scripts_html($id);
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			if($action=="name")
			{
				print("<div class=\"detail-box\">\n");
				print("<img src=\"img/name.png\" align=\"left\"/>\n");
				print("<h2>Name Cluster $id</h2>\n");
				print("<p>Give your cluster a name for easier identification!</p>");
				$name=get_cluster_name($id);
				print_update_name_html($id, $name);
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			if($action=="addmysqld")
			{
				print("<div class=\"detail-box\">\n");
				print("<img src=\"img/blank.png\" align=\"left\"/>\n");
				print("<h2>Add MySQL server to Cluster '$name'</h2>\n");
				print("<p>The current mgmapi is really crap and cannot distinguish between a mysql server or any other ndbapi program. Thus you need to help CMON locate the mysql servers!</p>");
				//	$name=get_cluster_name($id);
				//	print_add_mysqld_html($id, $name);
				print_add_mysqld_html($id);
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			
			if($action=="listmysqld")
			{
				list_mysqld( $id);
			}
			
			if($action=="removemysqld")
			{
				print("<div class=\"detail-box\">\n");
				print("<h2>Remove MySQL server from Cluster '$name'</h2>\n");
				print("<p>This removes the mysql server from the cmon monitor, but it will remain part of the cluster.</p>");
				print_mysqld_status($id, "1", 0);
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			return;
		}
		/*
		 submit=Update , we have work to do (update database, etc)
		 */
		if($submit=="Update"  || $submit=="Remove")
		{
			if($action=="config")
			{
				print("<div class=\"detail-box\">\n");
				print("<h2>Configuring Scripts for  Cluster $id</h2>\n");
				$scriptsdir= isset($_GET['scriptsdir']) ? $_GET['scriptsdir'] : "";	
				perform_script_fetch($id, $scriptsdir);
				print("<p>The scripts was successfully configured<br><a href=\"index.php?action=view&id=$id\">Refresh</a> the page.</p>\n");
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			if($action=="update")
			{
				print("<div class=\"detail-box\">\n");
				print("<img src=\"img/update.png\" align=\"left\"/>\n");
				print("<h2>Update Scripts for Cluster $id</h2>\n");
				$scriptsdir= isset($_GET['scriptsdir']) ? $_GET['scriptsdir'] : "";	
				perform_script_fetch($id, $scriptsdir);
				print("<p>The scripts was successfully configured<br><a href=\"index.php?action=view&id=$id\">Refresh</a> the page.</p>\n");
				print("<br clear=\"all\"/></p>\n");
				print("</div>\n");
			}
			if($action=="name")
			{
				
				$name= isset($_GET['clustername']) ? $_GET['clustername'] : "";	
				if($name)
				{
					print("<div class=\"detail-box\">\n");
					print("<img src=\"img/name.png\" align=\"left\"/>\n");
					print("<h2>Name Cluster $id</h2>\n");
					set_cluster_name($id, $name);
					print("<p>The name was successfully changed to '$name'<br><a href=\"index.php?action=view&id=$id\">Refresh</a> the page.</p>\n");
					print("<br clear=\"all\"/></p>\n");
					print("</div>\n");
				} 
			}
			if($action=="addmysqld")
			{
				print("<div class=\"detail-boxsmall\">\n");
				print("<img src=\"img/blank.png\" align=\"left\"/>\n");
				print("<h2>Add MySQL server</h2>\n");
				if(add_mysqld($id, $_GET["hostname"],$_GET["port"],isset($_GET["username"]) ? $_GET["username"] : "cmon" ,$_GET["password"]))
				{
					print("<h3>Adding the mysql server was successful.</h3>\n");
					print("<p><br><a href=\"viewmysqld.php?id=$id\">Refresh</a> the page or click here to <a href=\"config.php?action=addmysqld&id=1\">add a another mysql server</a>.</p>\n");
					
				}
				else
					print("<h3>Failed adding the mysql server.</h3>\n");
				
				print("</div>\n");
			}
			
			if($action=="removemysqld")
			{
				print("<div class=\"detail-box\">\n");
				print("<img src=\"img/blank.png\" align=\"left\"/>\n");
				print("<h2>Remove MySQL server</h2>\n");
				$nodes=array();
				$max=isset($_GET["max"]) ? $_GET["max"] : 0;
				$i=0;
				for($i=0;$i<$max;$i++)
				{
					$nodeid=$_GET["mysql_$i"];
					if($nodeid!="")
						$nodes[]=$nodeid;
				}
				if(remove_mysqld($id, $nodes))
				{
					print("<h3>Removing the mysql server(s) was successful.</h3>\n");
					print("<p><br><a href=\"viewmysqld.php?id=$id\">Refresh</a> the page.</p>\n");
				}
				else
					print("<h3>Failed removing the mysql server(s).</h3>\n");
				
				print("</div>\n");
			}
			return;
		}
		
	}
	
	function list_mysqld( $id)
	{
		if($id<1)
		{
			die("No cluster selected. Select a Cluster first.");
		}
		print("<div class=\"detail-box\">\n");
		$name=get_cluster_name($id);
		if($name=="")	  
			$name=$id;
        print("<h2>Viewing MySQL servers for cluster '$name' </h2>\n");
		$retval=print_mysqld_status($id,"0","0");
		print("<br clear=\"all\"/></p>\n");
    	print("</div>\n");
		return $retval;
	}
	
	function list_mysqld_selected( $id, $host)
	{
		if($id<1)
		{
			die("No cluster selected. Select a Cluster first.");
		}
		print("<div class=\"detail-box\">\n");
		$nodeid=0;
		$name=get_cluster_name($id);
		if($host!="")
			$nodeid=get_mysqld_nodeid($id,$host);
		if($name=="")	  
			$name=$id;
		
		print("<h2>Viewing MySQL servers for cluster '$name' </h2>\n");
		
		$retval=print_mysqld_status($id,"0",$nodeid);
		print("<br clear=\"all\"/></p>\n");
		print("</div>\n");
		return $retval;
	}
	
	function add_mysqld($cid, $hostname, $port, $username, $password)
	{
		
		$dbh = connect();
		if(!$dbh)
			die();
		if($username=="")
			$username="cmon";
		$query=sprintf("INSERT INTO mysql_server(cid, hostname, password, username, port) VALUES(%d, '%s', '%s', '%s', %d)",
					   $cid,
					   mysql_real_escape_string($hostname),
					   mysql_real_escape_string($password),
					   mysql_real_escape_string($username),
					   $port);
		
		$result=mysql_query($query);
		$rows=mysql_affected_rows($dbh);
		if($rows<1)
		{
			echo "Writing to to cmon.mysql_server failed " . mysql_error($dbh) . "<br>\n";
			return 0;
		}
		mysql_close($dbh);
		return 1;
	}
	
	
	function remove_mysqld($cid, $nodes)
	{
		
		$dbh = connect();
		if(!$dbh)
			die();
		foreach ($nodes as &$n)	
		{
			$result=mysql_query("DELETE FROM mysql_server WHERE cid=$cid and nodeid=$n");
			$result=mysql_query("DELETE FROM mysql_statistics WHERE cid=$cid and nodeid=$n");
		}
		
		mysql_close($dbh);
		return 1;
	}
	
	
	function print_mysqld_status($id, $remove, $selected)
	{
		
		$mysql_nodes_arr=get_mysql_records($id);
		if(count($mysql_nodes_arr) <=0)
		{
			printf("There are no mysql servers being monitored by cmon.<br>");
			printf("You must <a href=\"config.php?action=addmysqld&id=$id\">add mysql server</a> first");
			return false;
		}
		if($remove)
		{
			print ("<fieldset>\n<form action=\"config.php\" method=\"get\">");
			print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
			print ("<input type=\"hidden\" name=\"action\" value=\"removemysqld\"/>"); 
		}
		print("<table class=\"small\">\n");
		print("<tr class=\"hed\">\n");
		if($remove)
		{
			print("<td class=\"hed\">\n");
			print("remove");
			print("</td>\n");
		}
		print("<td class=\"hed\">\n");
		print("nodeid");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("hostname");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("port");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("status");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("replication<br>role");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("last reported");
		print("</td>\n");
		if(!$remove)
		{
			print("<td class=\"hed\">\n");
			print("details");
			print("</td>\n");
		}
		print("<td class=\"hed\">\n");
		print("last error");
		print("</td>\n");
		print("</tr>\n");
		$i=0;
		foreach ($mysql_nodes_arr as &$api)
		{ 
			
			$hname=$api["host"];
			$nodeid=$api["nodeid"];
			$port=$api["port"];
			$status=$api["status"];
			$role=$api["role"];
			$report_ts=$api["report_ts"];	      
			$msg=$api["msg"];	      
			$warning=$api["report_warning"];
			$light=get_traffic_light($status, $warning);
			$status_txt="";
			if($light=="green")
				$status_txt="Connected";
			else
				$status_txt="No contact";
			
			$c="";
			if($selected==$nodeid)
			{
				
				$light= $light. "selected";
				$c="class=\"selected\"";
			}
			
			if($remove)
				print("<tr class=\"hed2\"><td><input type=\"checkbox\" name=\"mysql_". $i .  "\" value=\"" . $nodeid .  "\"> </td><td>". $nodeid. "</td><td>". $hname . "</td><td>". $port . "</td><td  class=\"" . $light . "\">" . $status_txt . "</td><td>". $role . "</td><td>". $report_ts . "</td><td align=\"left\">". $msg. " </td></tr>");
			else
			{
				if($selected==$nodeid)
					print("<tr class=\"selected\">");
				else
					print("<tr class=\"hed2\">");
				$rolelink="none";
				if($role=="slave")
				{
					$rolelink="<a href=\"replication.php?id=$id&nodeid=$nodeid&role=$role&hostname=$hname&port=$port\">slave</a>";
				}
				if($role=="master")
				{
					$rolelink="<a href=\"replication.php?id=$id&nodeid=$nodeid&role=$role&hostname=$hname&port=$port\">master</a>";
				}
				print("<td $c>". $nodeid. "</td><td $c>". $hname . "</td><td $c>". $port . "</td><td  class=\"" . $light . "\">" . $status_txt . "</td><td $c>". $rolelink . "</td><td $c>". $report_ts . "</td><td $c>" . "<a href=\"viewnode.php?id=$id&nodeid=$nodeid&mysql_host=$hname&mysql_port=$port\">view</a>&nbsp;<a href=\"statistics.php?id=$id&host=$hname|$port&view=mysqld\">graphs</a></td><td  $c align=\"left\">". $msg . "</td></tr>");
			}
			$i++;
		}
		
		if($remove)
		{
			print ("<input type=\"hidden\" name=\"max\" value=\"$i\"/>"); 
			print ("<tr><td><input tabindex=\"2\" name=\"submit\" type=\"submit\" value=\"Remove\"/></td></tr>");
			print("</form>\n</fieldset>\n\n");
		}
		
		print("</table>\n");
		return true;
	}
	
	
	function print_replication_status($id, $remove, $selected)
	{
		
		$mysql_nodes_arr=get_replicationserver_record($id);
		if(count($mysql_nodes_arr) <=0)
		{
			printf("There are no mysql servers being monitored by cmon.<br>");
			printf("You must add one first.");
			return false;
		}
		if($remove)
		{
			print ("<fieldset>\n<form action=\"config.php\" method=\"get\">");
			print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
			print ("<input type=\"hidden\" name=\"action\" value=\"removemysqld\"/>"); 
		}
		print("<table class=\"small\">\n");
		print("<tr class=\"hed\">\n");
		if($remove)
		{
			print("<td class=\"hed\">\n");
			print("remove");
			print("</td>\n");
		}
		print("<td class=\"hed\">\n");
		print("nodeid");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("hostname");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("port");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("status");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("replication<br>role");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("last reported");
		print("</td>\n");
		if(!$remove)
		{
			print("<td class=\"hed\">\n");
			print("details");
			print("</td>\n");
		}
		print("</tr>\n");
		$i=0;
		foreach ($mysql_nodes_arr as &$api)
		{ 
			
			$hname=$api["host"];
			$nodeid=$api["nodeid"];
			$port=$api["port"];
			$status=$api["status"];
			$role=$api["role"];
			$report_ts=$api["report_ts"];	      
			$warning=$api["report_warning"];	      
			
			$light=get_traffic_light($status, $warning);
			$status_txt="";
			if($light=="green")
				$status_txt="Connected";
			else
				$status_txt="No contact";
			
			if($selected==$nodeid)
			{
				
				$light= $light. "selected";
			}
			
			if($remove)
				print("<tr class=\"hed2\"><td><input type=\"checkbox\" name=\"mysql_". $i .  "\" value=\"" . $nodeid .  "\"> </td><td>". $nodeid. "</td><td>". $hname . "</td><td>". $port . "</td><td  class=\"" . $light . "\">" . $status_txt . "</td><td>". $role . "</td><td>". $report_ts . "</td></tr>");
			else
			{
				if($selected==$nodeid)
					print("<tr class=\"selected\">");
				else
					print("<tr class=\"hed2\">");
				$rolelink="none";
				if($role=="slave" || $role=="mixed")
				{
					$rolelink="<a href=\"replication.php?id=$id&nodeid=$nodeid&role=$role&hostname=$hname&port=$port\">$role</a>";
				}
				
				if($role=="master")
				{
					$rolelink="<a href=\"replication.php?id=$id&nodeid=$nodeid&role=$role&hostname=$hname&port=$port\">master</a>";
				}
				print("<td>". $nodeid. "</td><td>". $hname . "</td><td>". $port . "</td><td  class=\"" . $light . "\">" . $status_txt . "</td><td>". $rolelink . "</td><td>". $report_ts . "</td><td>" . "<a href=\"viewnode.php?id=$id&nodeid=$nodeid\">view</a>&nbsp;<a href=\"statistics.php?id=$id&host=$hname|$port&view=mysqld\">graphs</a></td></tr>");
			}
			$i++;
		}
		
		if($remove)
		{
			print ("<input type=\"hidden\" name=\"max\" value=\"$i\"/>"); 
			print ("<tr><td><input tabindex=\"2\" name=\"submit\" type=\"submit\" value=\"Remove\"/></td></tr>\n");
			print("</form>\n</fieldset>\n");
		}
		
		print("</table>\n");
		return true;
	}
	
	
	
	function print_viewnode_html($id, $nodeid, $mysql_host, $mysql_port)
	{ 	 
		$name=get_cluster_name($id);
		$type=get_node_type($id,$nodeid);
		$status=get_node_status($id,$nodeid);
		if($type=="API")
			$type="MySQLD";
		
		if($name=="")
			$name=$id;
		print("<h1>Cluster - '" . $name . "'</h1>");
		print("<div class=\"detail-box\">\n");
		if($type=="MySQLD")
		{
			print("<h2>MySQL Servers monitored by CMON</h2>\n");	
			print_mysqld_status($id, "0", $nodeid);
		}
		if($type=="NDBD")
		{
			print("<h2>Data nodes monitored by CMON</h2>\n");	
			print_ndbd_status($id, "view", $nodeid);
		}
		if($type=="NDB_MGMD")
		{
			print("<h2>Management serves monitored by CMON</h2>\n");		     
			print_ndb_mgmd_status($id, "view");
		}
		print("<br clear=\"all\"/></p>\n");
		print("</div>\n");
		print("<div class=\"detail-box\">\n");
		print("<h2>Viewing node id $nodeid ($type) -  Cluster '$name'</h2>\n");
		print_details($id,$nodeid, $mysql_host, $mysql_port);
		print("<br clear=\"all\"/></p>\n");
		print("</div>\n");
	}
	
	function print_details($id,$nodeid, $mysql_host, $mysql_port)
	{
		$name=get_cluster_name($id);
		$type=get_node_type($id,$nodeid);
		
		$status=get_node_status($id,$nodeid);
		if($type=="API")
			$type="MySQLD";
		
		if($type=="MySQLD")
		{		
			$role=get_mysqld_role($id,$nodeid);
			print_mysqld_details($id, $nodeid, $mysql_host, $mysql_port);
			
		}
		if($type=="NDBD")
		{
			require_once('helpers/datanode.php');
			$mem_arr=get_memory_node($id, $nodeid);
			print("<table class=\"smallblack\">");
			print("<tr class=\"hed\"><td class=\"hed\">Resource</td><td class=\"hed\">Free (MB)</td><td class=\"hed\">Used (MB)</td><td class=\"hed\">Total (MB)</td></tr>\n");
			print("<tr><td>DataMemory</td><td>" . $mem_arr["dm_free_mb"]  . "</td><td>" . $mem_arr["dm_used_mb"] . "</td><td>" . $mem_arr["dm_total_mb"] . "</td></tr>\n");
			print("<tr><td>IndexMemory</td><td>" . $mem_arr["im_free_mb"]  . "</td><td>" . $mem_arr["im_used_mb"] . "</td><td>" . $mem_arr["im_total_mb"] . "</td></tr>\n");
			
			print("</table>");
			
			
		}
		if($type=="NDB_MGMD")
		{
			print("<p>No info yet</p>");
		}
	}
	
	function perform_script_fetch($id, $scriptdir)
	{
		if($scriptdir=="")
			die("Path to Configurator scripts not set");
		
		$scripts_arr=array("ndbd_hostnames_ids");
		foreach ($scripts_arr as &$script)
		{
			$script_file=$scriptdir . "/cluster/scripts/install/.s9s/$script";
			echo "<br>".$script_file . "<br>";
			$data=shell_exec("cat $script_file | grep -v \"#\"");
			if($data=="")
				die("No script data found in the specified location: '$scriptdir'");
			persist_scriptdir($id,$scriptdir);
			$data_nodes_arr=array();
			$tok = strtok($data, " \n\t");
			$i=0;
			while ($tok !== false) {
				echo "node=$tok<br />";
				$data_nodes_arr[$i]=array();
				$node=explode(",",$tok);
				$data_nodes_arr[$i]["id"]=trim($node[0]," \n\t");
				$data_nodes_arr[$i]["hostname"]=trim($node[1]," \n\t");
				$tok = strtok("");	    
				$i++;
			}
			foreach ($data_nodes_arr as &$node)
			{
				persist_ndbd_map($id,$node);
			}
		}
	}
	
	function persist_ndbd_map($id, $node)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			die();
		$nodeid= $node["id"];
		$hostname=$node["hostname"];
		$result=mysql_query("DELETE FROM configurator_nodemap WHERE  cid=$id AND nodeid=$nodeid");
		$result=mysql_query("REPLACE INTO configurator_nodemap(cid,nodeid,hostname) VALUES ($id, $nodeid, '$hostname')");
		$rows=mysql_affected_rows($dbh);
		if($rows<1)
		{
			die("Writing to to cmon.configurator_nodemap failed " . mysql_error($dbh));
		}
		mysql_close($dbh);
	}
	
	function is_node_mapped($id,$nodeid)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)	
			die();
		$rows=0;
		$result=mysql_query("SELECT hostname FROM configurator_nodemap WHERE  cid=$id AND nodeid=$nodeid", $dbh);
		$rows=mysql_num_rows($result);
		mysql_close($dbh);
		if($rows==0)
			return 0;
		else
			return 1;
	}
	
	function get_hostname_from_map($id,$nodeid)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			die();
		$hostname="";
		$result=mysql_query("SELECT hostname FROM configurator_nodemap WHERE  cid=$id AND nodeid=$nodeid", $dbh);
		while($row = mysql_fetch_array( $result )) 
		{
			$hostname=$row["hostname"];
		}
		mysql_close($dbh);
		return $hostname;
	}
	
	function get_scriptdir($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			die();
		$scriptdir="";
		$result=mysql_query("SELECT scriptsdir FROM cluster WHERE id=$id");
		while($row = mysql_fetch_array( $result )) 
		{
			$scriptdir=$row["scriptsdir"];
		}  
		mysql_close($dbh);
		return $scriptdir;
	}
	
	
	function persist_scriptdir($id, $scriptdir)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		
		$dbh = connect();
		if(!$dbh)
			die();
		
		$result=mysql_query("UPDATE cluster SET scriptsdir='$scriptdir' WHERE id=$id");
		$rows=mysql_affected_rows($dbh);
		if($rows<1)
		{
			die("Writing to to cmon.configurator_nodemap failed " . mysql_error($dbh));
		}
		mysql_close($dbh);
	}
	
	function  print_config_scripts_html($id)
	{
		print ("<fieldset>\n<form action=\"config.php?action=config&id=$id\" method=\"get\"><table width=200px>");
		print ("<tr>");
		print ("<td class=\"hedmedium\"> path to topdir of<br/>configurator scripts</td>");
		print ("<td>");
       	print ("<input type=\"hidden\" name=\"action\" value=\"config\"/>"); 
       	print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
		print ("<input name=\"scriptsdir\" type=\"text\" id=\"scriptsdir\" tabindex=\"1\" value=\"e.g: /root/mysqlcluster-70/\" size=40% maxlength=\"255\" /></td>");
		print ("<td><input tabindex=\"2\" name=\"submit\" size=10% type=\"submit\" value=\"Update\"/></td>");
		print ("</tr>\n");
		print ("</table>");
		print ("</form>\n</fieldset>\n");
		
	}
	
	
	function  print_update_name_html($id, $name)
	{	  
		print ("<fieldset>\n<form action=\"config.php?action=name&id=$id\" method=\"get\">\n");
       	print ("<input type=\"hidden\" name=\"action\" value=\"name\"/>"); 
       	print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
		print("<table>\n");
		print ("<tr>");
		print ("<td class=\"hedmedium\">Cluster name:</td>");
		print ("<td>");
		if($name=="")
        	print ("<input name=\"clustername\" type=\"text\" id=\"clustername\" tabindex=\"1\"  size=50% maxlength=\"255\" /></td>"); 
		else
			print ("<input name=\"clustername\" type=\"text\" id=\"clustername\" value=\"$name\" tabindex=\"1\" size=50%  maxlength=\"255\" /></td>");
		print ("<td><input tabindex=\"2\" name=\"submit\" type=\"submit\" value=\"Update\"/></td>");
		print ("</tr>\n");
		print ("</table>\n");
		print ("</form>\n</fieldset>\n");
	}
	
	
	function  print_add_mysqld_html($id)
	{	  
		print ("<fieldset>\n<form action=\"config.php\" method=\"get\">\n");
       	print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
       	print ("<input type=\"hidden\" name=\"action\" value=\"addmysqld\"/>"); 
		print("<table>\n");
		print ("<tr>");
		print ("<td width=\"30%\" class=\"hed\">hostname</td>");
		print ("<td><span style=\"width: 90%;\">");
		print ("<input name=\"hostname\" style=\"width: 90%;\" type=\"text\" id=\"hostname\" tabindex=\"1\"  maxlength=\"255\" /></span></td>");
		print ("</tr>\n");
		print ("<tr>");
		print ("<td width=\"30%\" class=\"hed\">port</td>");
		print ("<td><span style=\"width: 90%;\">");
		print ("<input name=\"port\" style=\"width: 90%;\" type=\"text\" id=\"port\"  tabindex=\"1\"   maxlength=\"255\" /></style></td>");
		print ("</tr>\n");
		print ("<tr>");
		print ("<td width=\"30%\" class=\"hed\">user name<br/>(cmon will use this to connect to the mysql)</td>");
		print ("<td>");
		print ("<input name=\"username\" disabled  style=\"width: 90%;\" type=\"text\" id=\"username\" value=\"cmon\"  tabindex=\"1\"  maxlength=\"255\" /></td>");
		print ("</tr>\n\n");
		print ("<tr>");
		print ("<td width=\"30%\" class=\"hed\" align=\"left\">password</td>");
		print ("<td>");
		print ("<input name=\"password\" style=\"width: 90%;\" type=\"text\" id=\"password\"  tabindex=\"1\"  maxlength=\"255\" /></td>");
		print ("</tr>\n\n");
		print ("</table>\n");
		print ("<input tabindex=\"2\" name=\"submit\" type=\"submit\" value=\"Update\"/>");
		print ("</form>\n</fieldset>\n");
		print ("<p>You have to GRANT the following on the mysql server you adding:<br>
			   <code>GRANT SELECT ON mysql.* TO 'cmon'@'hostname_where_cmon_runs' <br> IDENTIFIED BY '&lt;password you specified above&gt;'</code><code>GRANT REPLICATION CLIENT, SUPER ON *.* TO 'cmon'@'hostname_where_cmon_runs' <br> IDENTIFIED BY '&lt;password you specified above&gt;'</code></p>");
	}
	
	function print_mysqld_details($id, $nodeid, $mysql_host, $mysql_port)
	{
		$mysqld_arr=get_mysqld_stats($id, $nodeid, $mysql_host, $mysql_port);
		
		print("<h3>Basic statistics</h3>");
		print("<table align=center>\n");
		print ("<tr>");
		print ("<td class=\"hed\">Counter");
		print ("</td>");
		
		print ("<td  class=\"hed\">Current value");
		print ("</td>");
		
		print ("<td  class=\"hed\">Comment");
		print ("</td>");
		print ("</tr>\n");
		
		$i=0;
		$link="http://dev.mysql.com/doc/refman/5.1/en/server-status-variables.html#statvar_";
		foreach ($mysqld_arr as &$stat)
		{
			$c="";
			if ($i % 2 ==0)
				$c="\"even\"";
			else
				$c="\"odd\"";	    
			print ("<tr>");
			$v=ucfirst(strtolower($stat["KEY"]));
			if(strncmp($v, "Com", 3) == 0)	     
				$v="Com_xxx";   
			
			$linktmp=$link . $v;  
			print ("<td class=$c>");
			print("<a href=\"$linktmp\" target=\"_blank\">" . $stat["KEY"] . "</a>");
			print ("</td>");
			print ("<td class=$c>");
			print($stat["VALUE"]);
			print ("</td>");
			print ("<td class=$c>");
			print ("</td>");
			print ("</tr>\n");
			$i++;
		}
		
		
		print ("</table>");
	}
	
	function print_cluster_actions($id, $action)
	{
		$status = get_cluster_status($id);
		$status= convert_cluster_status($status);
		print("<table>\n");
        print("<tr>\n");
        print("<td>");
		//	if($status != "FAILURE")
	  	print("<a href=\"config.php?action=addmysqld&id=$id\">add mysql server</a>");
		//	else
		//          	print("stop cluster");
        print("</td>\n");
        print("<td>");
		print("<a href=\"config.php?action=listmysqld&id=$id\">view mysql servers</a>");
        print("</td>\n");
        print("<td>");
		/*	if($status == "FAILURE")
		 print("<a href=\"manage.php?action=startcluster&id=$id\" onClick=\"return popup(this,'test')\">start cluster</a>");
		 else
		 print("start cluster");
		 */
	  	print("<a href=\"config.php?action=removemysqld&id=$id\">remove mysql server</a>");
        print("</td>");
		/*        print("<td>");
		 if($status == "STARTED")
		 print("<a href=\"manage.php?action=rolling&id=$id\" onClick=\"return popup(this,'test')\">rolling restart</a>");
		 else
		 print("rolling restart");
		 print("</td>");
		 */
		
        print("</tr>\n\n");
		print("</table>\n");
	}
	
	function print_api_status($id,$type, $action)
	{
		
		$api_nodes_arr=get_api_record($id,$type);
		print("<table class=\"smallblack\">\n");
		print("<tr class=\"hed\">\n");
		print("<td class=\"hed\">\n");
		print("nodeid");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("hostname");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("status");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("version");
		print("</td>\n");
		print("<td class=\"hed\">\n");
		print("last reported");
		print("</td>\n");
		if($action=="manage")
		{
			/*
			 print("<td class=\"hed\">\n");
			 print("manage");
			 print("</td>\n");
			 */
		}
		print("<td class=\"hed\">\n");
		print("details");
		print("</td>\n");
		print("</tr>\n\n");
		$status="";
		$i=0;
		foreach ($api_nodes_arr as &$api)
		{ 	  
			$c="";
			if($i % 2 ==0)
				$c="\"even\"";
			else
				$c="\"odd\"";
			
			$hname=$api["host"];
			$nodeid=$api["nodeid"];
			$nodestatus=$api["status"];
			$report_ts=$api["report_ts"];	      
			$report_warning=$api["report_warning"];	      
			$version=$api["version"];	      
			$nodestatus=$api["status"];	      
			
			$status="<tr><td class=$c>". $nodeid. "</td><td class=$c>". $hname . "</td>";
			if($report_warning)
				if($i % 2 ==0)	
					$status = $status . "<td class=\"yellow\">" . "UNKNOWN" . "</td>";
				else
					$status = $status . "<td class=\"yellowodd\">" . "UNKNOWN" . "</td>";
				else
				{
					if(is_connected($nodestatus)) 
					{
						if($i % 2 ==0)	
							$status = $status . "<td class=\"green\">" . $nodestatus . "</td>";
						else
							$status = $status . "<td class=\"greenodd\">" . $nodestatus . "</td>";
					}
					else if(is_no_contact($nodestatus)) 
					{
						if($type=="API")
							$status = $status . "<td class=$c>Accepting connections</td>";
						else
							if($i % 2 ==0)	
								$status = $status . "<td class=\"red\">" . $nodestatus . "</td>";
							else
								$status = $status . "<td class=\"redodd\">" . $nodestatus . "</td>";
					}
					else 
					{  
						$status = $status . "<td class=\"yellow\">" . $nodestatus . "</td>";
					}
				}
			$status  = $status . "<td class=$c>" . $version . "</td>";
			
			print($status . "<td class=$c>" . $report_ts .   "</td>\n");
			
			if($action=="manage")
			{   
				/*
				 print("<td class=$c>");
				 $mapped=is_node_mapped($id,$nodeid);
				 if(is_connected($nodestatus) && $mapped )
				 {
				 print("<a href=\"manage.php?action=stop&id=$id&nodeid=$nodeid\" onClick=\"return popup(this,'test')\">stop</a>");
				 print("&nbsp;&nbsp;&nbsp;");
				 print("<a href=\"manage.php?action=restart&id=$id&nodeid=$nodeid\" onClick=\"return popup(this,'test')\">restart</a>");
				 
				 }	
				 if(is_no_contact($nodestatus))
				 {
				 print("<a href=\"manage.php?action=start&id=$id&nodeid=$nodeid\" onClick=\"return popup(this,'test')\">start</a>");
				 }
				 else if (!$mapped)
				 {
				 print("not mapped");
				 }	  
				 print("</td>");
				 */
			}
			print("<td class=$c>");
			if(is_connected($nodestatus) && is_mysqld($id, $nodeid))
			{
				print("<a href=\"viewnode.php?id=$id&nodeid=$nodeid\">view</a>");
			}
			print("</td>");
			print("</tr>\n\n");  
			$i++;
		}
		print("</table>\n");
		
	}
	
	function is_mysqld($id, $nodeid)
	{
		require_once ("helpers/cmon_db_connect.php");
		$dbh = connect();
		if(!$dbh)
			die();
		
		$result=mysql_query("SELECT nodeid  FROM mysql_server WHERE cid=$id AND nodeid=$nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());	
		}
		$nodeid=0;
		while($row = mysql_fetch_array( $result )) 
		{	     
			$nodeid=$row["nodeid"];
		}
		if($nodeid==0)
			return false;
		else
			return true;
	}
	
	function get_node_type($id,$nodeid)
	{
		require_once ("helpers/cmon_db_connect.php");
		$dbh = connect();
		if(!$dbh)
			die();
		$type="";
		$result=mysql_query("SELECT node_type FROM node_state WHERE cid=$id AND nodeid=$nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$api_nodes_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$type=$row["node_type"];
		}
		mysql_close($dbh);
		return $type;
	}
	
	function get_mysqld_role($id,$nodeid)
	{
		require_once ("helpers/cmon_db_connect.php");
		$dbh = connect();
		if(!$dbh)
			die();
		
		$result=mysql_query("SELECT role FROM mysql_server WHERE cid=$id AND nodeid=$nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		
		$i=0;
		$role="none";
		while($row = mysql_fetch_array( $result )) 
		{
			$role=$row["role"];
		}
		mysql_close($dbh);
		return $role;
	}
	
	function get_mysqld_nodeid($id,$host)
	{
		
		require_once ("helpers/cmon_db_connect.php");
		$dbh = connect();
		if(!$dbh)
			die();
		$hname=strtok($host,"|");
		$port=strtok(NULL);	
		
		$result=mysql_query("SELECT nodeid FROM mysql_server WHERE cid=$id AND port=$port AND hostname='$hname'");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		
		$i=0;
		$nodeid=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$nodeid=$row["nodeid"];
		}
		mysql_close($dbh);
		return $nodeid;
	}
	
	function get_api_record($id,$type)
	{
		
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		
		$result=mysql_query("SELECT nodeid, host, status, version, report_ts,(now()-report_ts)>300 as report_warning, node_type FROM node_state WHERE cid=$id AND node_type='". $type .  "' order by nodeid, status");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$api_nodes_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$api_nodes_arr[$i]=array();
			$api_nodes_arr[$i]["nodeid"]=$row["nodeid"];
			$api_nodes_arr[$i]["host"]=$row["host"];
			$api_nodes_arr[$i]["status"]=$row["status"];
			$api_nodes_arr[$i]["version"]=$row["version"];
			$api_nodes_arr[$i]["node_type"]=$row["node_type"];
			$api_nodes_arr[$i]["report_ts"]=$row["report_ts"];
			$api_nodes_arr[$i]["report_warning"]=$row["report_warning"];
			$i++;
		} 
		return $api_nodes_arr;
	}
	
	function has_replication($id)
	{
		$arr=get_replicationserver_record($id);
		if(count($arr)>0)
			return 1;
		return 0;
	}
	
	function get_replicationserver_record($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		
		$result=mysql_query("SELECT nodeid, hostname, port, role, connected as status, report_ts, (now()-report_ts)>60 as report_warning FROM mysql_server WHERE cid=$id and (role='slave' or role='mixed') order by nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$api_nodes_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$api_nodes_arr[$i]=array();
			$api_nodes_arr[$i]["nodeid"]=$row["nodeid"];
			$api_nodes_arr[$i]["host"]=$row["hostname"];
			$api_nodes_arr[$i]["status"]=$row["status"];
			$api_nodes_arr[$i]["port"]=$row["port"];
			$api_nodes_arr[$i]["role"]=$row["role"];
			$api_nodes_arr[$i]["report_ts"]=$row["report_ts"];
			$api_nodes_arr[$i]["report_warning"]=$row["report_warning"];
			$i++;
		} 
		return $api_nodes_arr;
	}
	
	function get_mysql_records($id)
	{
		
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		
		$result=mysql_query("SELECT nodeid, hostname, port, role, connected as status, report_ts, (now()-report_ts)>60 as report_warning ,msg FROM mysql_server WHERE cid=$id order by nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$api_nodes_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$api_nodes_arr[$i]=array();
			$api_nodes_arr[$i]["nodeid"]=$row["nodeid"];
			$api_nodes_arr[$i]["host"]=$row["hostname"];
			$api_nodes_arr[$i]["status"]=$row["status"];
			$api_nodes_arr[$i]["port"]=$row["port"];
			$api_nodes_arr[$i]["role"]=$row["role"];
			$api_nodes_arr[$i]["msg"]=$row["msg"];
			$api_nodes_arr[$i]["report_ts"]=$row["report_ts"];
			$api_nodes_arr[$i]["report_warning"]=$row["report_warning"];
			$i++;
		} 
		return $api_nodes_arr;
	}
	
	
	function get_mysql_record($id, $nodeid)
	{
		
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		$result=mysql_query("SELECT nodeid, hostname, port, role, connected as status, report_ts, (now()-report_ts)>60 as report_warning, msg FROM mysql_server WHERE cid=$id AND nodeid=$nodeid");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$api_nodes_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{
			$api_nodes_arr["nodeid"]=$row["nodeid"];
			$api_nodes_arr["host"]=$row["hostname"];
			$api_nodes_arr["status"]=$row["status"];
			$api_nodes_arr["port"]=$row["port"];
			$api_nodes_arr["role"]=$row["role"];
			$api_nodes_arr["msg"]=$row["msg"];
			$api_nodes_arr["report_ts"]=$row["report_ts"];
			$api_nodes_arr["report_warning"]=$row["report_warning"];
			$i++;
		} 
		return $api_nodes_arr;
	}
	
	
	function get_ndb_record($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		$type="NDBD";
		
		$result=mysql_query("SELECT nodeid, host, nodegroup, status, version, report_ts, (now()-report_ts)>60 as report_warning,node_type FROM node_state WHERE cid=$id AND node_type='". $type .  "' order by nodeid, status");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$data_nodes_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{   
			$data_nodes_arr[$i]=array();
			$data_nodes_arr[$i]["nodeid"]=$row["nodeid"];
			$data_nodes_arr[$i]["host"]=$row["host"];
			$data_nodes_arr[$i]["status"]=$row["status"];
			$data_nodes_arr[$i]["version"]=$row["version"];
			$data_nodes_arr[$i]["node_type"]=$row["node_type"];
			$data_nodes_arr[$i]["report_ts"]=$row["report_ts"];
			$data_nodes_arr[$i]["report_warning"]=$row["report_warning"];
			$data_nodes_arr[$i]["nodegroup"]=$row["nodegroup"];
			$i++;
		}
		mysql_close($dbh);
		return $data_nodes_arr;
	}
	
	
	
	
	function get_mysqld_stats($id, $nodeid, $mysql_host, $mysql_port)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		if($mysql_host=="")
			$result=mysql_query("SELECT var,value  FROM mysql_server as m, mysql_statistics as s  WHERE m.cid=s.cid AND  m.cid=$id AND m.nodeid=$nodeid AND m.id=s.id ORDER BY var ASC");
		else
			$result=mysql_query("SELECT var,value  FROM mysql_server as m, mysql_statistics as s  WHERE m.cid=s.cid AND  m.cid=$id AND m.hostname='$mysql_host' AND m.port=$mysql_port AND m.id=s.id ORDER BY var ASC");
		if (!$result) {
			die('Invalid query: ' . mysql_error());	
		}
		$mysqld_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{   
			$mysqld_arr[$i]=array();
			$mysqld_arr[$i]["KEY"]=$row["var"];
			$mysqld_arr[$i]["VALUE"]=$row["value"];
			$i++;
		}
		mysql_close($dbh);
		return $mysqld_arr;
	}
	
	function get_traffic_light_memory($memory)
	{
		if($memory<80)
			return "green";
		if($memory>=80 && $memory<=90)
			return "yellow";
		if($memory>90)
			return "red";
		return "green";
	}
	
	
	
	
	
	function get_total_memory_util($id)
	{
		require_once ("helpers/cmon_db_connect.php");
		require_once ("helpers/bl.php");
		$dbh = connect();
		$result=mysql_query("select round(100*(sum(pg_used_im)/sum(pg_tot_im)),2) as im, round(100*(sum(pg_used_dm)/sum(pg_tot_dm)),2) as dm  from memory_usage where cid=$id");
		if (!$result) {
			die('Invalid query: ' . mysql_error());
		}
		$memory_arr=array();
		$i=0;
		while($row = mysql_fetch_array( $result )) 
		{   
			$memory_arr["im"]=$row["im"];
			$memory_arr["dm"]=$row["dm"];
			$i++;
		}
		mysql_close($dbh);
		return $memory_arr;
	}
	
	?>
