<?php
function print_replication_html($id)
{  

   list_replication_servers($id);

   print_replication_link_html($id);
 
	
}

function list_replication_servers( $id)
{
   if($id<1)
   {
     die("No cluster selected. Select a Cluster first.");
   }
       print("<div class=\"detail-box\">\n");
	$name=get_cluster_name($id);
	if($name=="")	  
	  $name=$id;
        print("<h2>Viewing replication servers for cluster '$name' </h2>\n");
	$retval=print_replication_status($id,"0","0");
  	print("<br clear=\"all\"/></p>\n");
    	print("</div>\n");

}
function   print_replication_link_html($id)
{
    $replinks= get_replication_links($id);
    
    foreach ($replinks as &$replink)
    {
     $active="";
    if($replink["report_warning"])
    { 
       $active="UNKNOWN - see WARNING message below";
    } 
    else
    {
     if($replink["running"] == "yes")	
        $active="ACTIVE";
     else
        $active="INACTIVE";
    }
      print("<div class=\"detail-replbox\">\n");        
      print("<h3>Replication link from '". $replink["master_cluster_name"] .  "' to '" . $replink["slave_cluster_name"] . "' (" . $active . ")</h3>\n");
    print("<div class=\"smallbox2\">\n");
    print("<h4>master</h4>");	
    print("<table class=\"noborder\">");
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("master host:");
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["master_host"] . ":" . $replink["master_port"]);
    print("</td></tr>");
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("master log pos:");
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["log_pos_master"]);
    print("</td></tr>");
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("master log file:");
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["log_file_master"]);
    print("</td></tr>");
   print("<td class=\"noborderbold\">");	
   print("last updated:");	
   print("</td>");
   print("<td class=\"noborder\">");
   print($replink["report_ts"]);
   print("</td></tr>");
    print("</table");
    print("</div>\n");

    print("<div class=\"smallbox3\">\n");
    if($replink["report_warning"])
    {
   	 print("<center><img src=\"img/exclamation.jpg\"/></center>\n");
    }
    else
    {
	if($replink["running"] == "yes")
       	 print("<center><img src=\"img/progress2.gif\"/></center>\n");
    	else
         print("<center><img src=\"img/stop.jpg\"/></center>\n");
    } 
    print("</div>\n");


    print("<div class=\"smallbox2\">\n");
    print("<h4>slave</h4>");
    print("<table class=\"noborder\">");
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("working:");	
    print("</td>");
    print("<td class=\"noborder\">");
    if($replink["report_warning"])
    { 
	print("Unknown");
    }
    else
	print($replink["running"]);
    print("</td></tr>");
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("link status:");	
    print("</td>");
    print("<td class=\"noborder\">");
    if($replink["report_warning"])
    { 
	print("Unknown");
    }
    else
	print($replink["slave_status"]);
    print("</td></tr>");
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("last applied epoch:");	
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["epoch"]);
    print("</td></tr>"); 
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("reading master binlog file:");	
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["relay_master_log_file"]);
    print("</td></tr>"); 
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("executed log pos on slave:");	
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["exec_master_log_pos"]);
    print("</td></tr>"); 
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("read log pos from master:");	
    print("</td>");
    print("<td class=\"noborder\">");
    if($replink["read_master_log_pos"] > $replink["log_pos_master"])
       print($replink["log_pos_master"]);
    else
       print($replink["read_master_log_pos"]);
    print("</td></tr>"); 
    print("<tr>");
    print("<td class=\"noborderbold\">");
    print("seconds behind master:");	
    print("</td>");
    print("<td class=\"noborder\">");
    print($replink["seconds_behind_master"]);
    print("</td></tr>");
    if($replink["running"] == "no")
    {
	print("<tr>");
    	print("<td class=\"noborderbold\">");
    	print("Slave IO Running:");	
    	print("</td>");
    	print("<td class=\"noborder\">");
    	print($replink["slave_io_running"]);
    	print("</td></tr>");
	print("<tr>");
        print("<td class=\"noborderbold\">");
	print("Slave SQL Running:");	
    	print("</td>");
    	print("<td class=\"noborder\">");
    	print($replink["slave_sql_running"]);
    	print("</td></tr>");
    }
   print("<tr>");
   print("<td class=\"noborderbold\">");	
   print("last updated:");	
   print("</td>");
   print("<td class=\"noborder\">");
   print($replink["report_ts"]);
   print("</td></tr>");
    print("</table");
    print("</div>\n");
    print("<div class=\"smallclear\">\n");

    print("</div>\n"); //smallbox2
    if($replink["report_warning"])
    {
        print("<table class=\"noborder\">");
	print("<tr>");
	print("<td class=\"noborderbold\">");	
	print("WARNING:");	
	print("</td>");
	print("<td class=\"noborder\">");
    	print("The replication link status has not been updated for 60s - check if CMON agents are running!");
	print("</td></tr></table>");
    }
    if($replink["running"] == "no")
    {
        print("<h4>The following errors exists:</h4>");
        print("<table class=\"noborder\">");
	$empty1=1;
	$empty2=1;
	if($replink["last_sql_error"]!="")
	{
		print("<tr>");
	        print("<td class=\"noborderbold\">");	
		print("last SQL error:");	
	    	print("</td>");
		print("<td class=\"noborder\">");
	    	print($replink["last_sql_error"]);
		print("</td></tr>");
		$empty1=0;
	}
	if($replink["last_io_error"]!="")
	{
		print("<tr>");
        	print("<td class=\"noborderbold\">");	
		print("last IO error:");	
	    	print("</td>");
	    	print("<td class=\"noborder\">");
		print($replink["last_io_error"]);
  		print("</td></tr>");
		$empty2=0;
	 }
	print("</table>");
    }
    print("</div>\n");  //detailbox-2
    }
    
}


function get_replication_links($id)
{
   $name=get_cluster_name($id);
   if($name == "")
     $name=$id;
     
   $dbh = connect();

  $result=mysql_query("SELECT (now()-s.report_ts)>60 as report_warning, s.report_ts,master_host,master_port,serverid, epoch,Slave_IO_State,Slave_IO_Running ,Slave_SQL_Running, Seconds_Behind_Master, Relay_Master_Log_File, Master_Log_File,Exec_Master_Log_Pos,Read_Master_Log_Pos, Last_IO_Error, Last_SQL_Error FROM mysql_server as server, mysql_slave_status as s WHERE server.cid=$id and server.cid=s.cid and server.id=s.id and (server.role='slave' or server.role='mixed')  order by s.cid, s.id");
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  $replication_link_arr=array();
  $i=0;
  while($row = mysql_fetch_array( $result )) 
  {
	$replication_link_arr[]=array();	
	$replication_link_arr[$i]["master_port"]=$row["master_port"];
	$replication_link_arr[$i]["master_host"]=$row["master_host"];	
	$replication_link_arr[$i]["slave_status"]=$row["Slave_IO_State"];
	$replication_link_arr[$i]["slave_io_running"]=$row["Slave_IO_Running"];
	$replication_link_arr[$i]["slave_sql_running"]=$row["Slave_SQL_Running"];
	$seconds=isset($row["Seconds_Behind_Master"])?$row["Seconds_Behind_Master"] : "null";
	$replication_link_arr[$i]["seconds_behind_master"]=$seconds;
 	if($row["Master_Log_File"])
		$replication_link_arr[$i]["master_log_file"]=$row["Master_Log_File"];
	else
		$replication_link_arr[$i]["master_log_file"]="no info";
	
	$replication_link_arr[$i]["exec_master_log_pos"]=$row["Exec_Master_Log_Pos"];
	$replication_link_arr[$i]["relay_master_log_file"]=$row["Relay_Master_Log_File"];
	$replication_link_arr[$i]["read_master_log_pos"]=$row["Read_Master_Log_Pos"];
	$replication_link_arr[$i]["epoch"]=$row["epoch"];
	$replication_link_arr[$i]["last_io_error"]=$row["Last_IO_Error"];
	$replication_link_arr[$i]["last_sql_error"]=$row["Last_SQL_Error"];
	$replication_link_arr[$i]["serverid"]=$row["serverid"];
	$replication_link_arr[$i]["report_ts"]=$row["report_ts"];
	$replication_link_arr[$i]["report_warning"]=$row["report_warning"];
	$running="no";       
        $running =is_replication_link_running($row["Slave_IO_Running"], $row["Slave_SQL_Running"], $row["Seconds_Behind_Master"]);
	$replication_link_arr[$i]["running"]=$running;
	$replication_link_arr[$i]["master_cluster_name"]=get_master_cluster($row["master_host"],$row["master_port"]);
	$replication_link_arr[$i]["slave_cluster_name"]=$name;		
	$h=$row["master_host"];
	$p=$row["master_port"];

	$res2=mysql_query("select File,Position,ms.report_ts as report_ts,connected from cmon.mysql_server as  ms , mysql_master_status as  mms where ms.cid=mms.cid and ms.hostname='$h' and ms.port=$p");
        if (!$res2) {
 	   die('Invalid query: ' . mysql_error());
  	}
  	while($row2 = mysql_fetch_array( $res2 )) 
  	{
		$replication_link_arr[$i]["log_pos_master"]=$row2["Position"];
		$replication_link_arr[$i]["log_file_master"]=$row2["File"];
	}
        $i++;
  } 
 return $replication_link_arr;
}

function get_replication_link($id, $hostname, $port)
{
   $name=get_cluster_name($id);
   if($name == "")
     $name=$id;
     
   $dbh = connect();

  $result=mysql_query("SELECT s.report_ts,master_host,master_port,serverid, epoch,Slave_IO_Running ,Slave_SQL_Running, Seconds_Behind_Master, Master_Log_File,Exec_Master_Log_Pos,Read_Master_Log_Pos, Last_IO_Error, Last_SQL_Error FROM mysql_server as server, mysql_slave_status as s WHERE server.cid=$id and server.cid=s.cid and server.id=s.id and server.hostname='$hostname' and server.port=$port order by s.cid, s.id");
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  $replication_link_arr=array();

  while($row = mysql_fetch_array( $result )) 
  {
	
	$replication_link_arr["master_port"]=$row["master_port"];
	$replication_link_arr["master_host"]=$row["master_host"];
	$replication_link_arr["slave_io_running"]=$row["Slave_IO_Running"];
	$replication_link_arr["slave_sql_running"]=$row["Slave_SQL_Running"];
	$seconds=isset($row["Seconds_Behind_Master"])?$row["Seconds_Behind_Master"] : "null";
	$replication_link_arr["seconds_behind_master"]=$seconds;
 	if($row["Master_Log_File"])
		$replication_link_arr["master_log_file"]=$row["Master_Log_File"];
	else
		$replication_link_arr["master_log_file"]="no info";
	$replication_link_arr["log_pos_master"]=$row["Position"];
	$replication_link_arr["log_file_master"]=$row["File"];
	$replication_link_arr["exec_master_log_pos"]=$row["Exec_Master_Log_Pos"];
	$replication_link_arr["read_master_log_pos"]=$row["Read_Master_Log_Pos"];
	$replication_link_arr["epoch"]=$row["epoch"];
	$replication_link_arr["last_io_error"]=$row["Last_IO_Error"];
	$replication_link_arr["last_sql_error"]=$row["Last_SQL_Error"];
	$replication_link_arr["serverid"]=$row["serverid"];
	$replication_link_arr["report_ts"]=$row["report_ts"];
	$running="no";       
        $running =is_replication_link_running($row["Slave_IO_Running"], $row["Slave_SQL_Running"], $row["Seconds_Behind_Master"]);
	$replication_link_arr["running"]=$running;
	$replication_link_arr["master_cluster_name"]=get_master_cluster($row["master_host"],$row["master_port"]);
	$replication_link_arr["slave_cluster_name"]=$name;		
	
  } 
 return $replication_link_arr;

}

function is_replication_link_running($io, $sql, $lag)
{
   if($io=="Yes" && $sql=="Yes"  && $lag!="null")
      return "yes";
    else return "no";
}

function get_master_cluster($host, $port)
{
//  $result=mysql_query("SELECT master_ FROM mysql_server as m, mysql_master_status as s WHERE m.cid=$id and m.cid=s.cid and m.id=s.id and m.hostname='$hostname' and m.port=$port order by s.cid, s.id");
  $result=mysql_query("SELECT cid FROM mysql_server as m  WHERE m.hostname='$host' and m.port=$port order by m.cid, m.id limit 1");
  if (!$result) {
    die('Invalid query: ' . mysql_error());
  }
  $master_arr=array();
  $cid=0;
  while($row = mysql_fetch_array( $result )) 
  {	     
      $cid=$row["cid"];
      $name=get_cluster_name($cid);
  }
  if($name == "")
     $name=$cid;
  return $name;

}

?>