<!-- 
Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  
  <head>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
    <meta name="description" content="description"/>
    <meta name="keywords" content="keywords"/> 
    <meta name="author" content="author"/> 
    <link rel="stylesheet" type="text/css" href="default.css" media="screen"/>
    <title>cmon - cluster enterprise monitor</title>
    <script type="text/javascript" src="http://www.google.com/jsapi?key=ABQIAAAARkAG6D2wnMUC54YC-EGAWRRBlzCrgfdFdXEANyMvf809G0kYqhSfawCaUJ2MYLcvgCevpXI4gjO2UQ"></script>
    <script type="text/javascript" src="rssdisplayer.js"></script>
    <script type="text/javascript" src="prototype.js"></script>
    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3/jquery.min.js"></script>
       <script type="text/javascript">
          var refresh=10000;
          $(function(){
	  document.$_GET = [];
	  var urlHalves = String(document.location).split('?');
	  if(urlHalves[1]){
	  var urlVars = urlHalves[1].split('&');
	  for(var i=0; i<=(urlVars.length); i++){
					    if(urlVars[i]){
					    var urlVarPair = urlVars[i].split('=');
					    document.$_GET[urlVarPair[0]] = urlVarPair[1];
					    }
					    }
					}
	     var doc="";
             if(document.$_GET['action'] && document.$_GET['id'])
                doc="$('#clusterstatus').load(" + "'get_cluster.php?action=" + document.$_GET['action']  + "&id=" + document.$_GET['id'] + "');";
	     else
                doc="$('#clusterstatus').load(" + "'get_cluster.php');";

             setInterval(doc,refresh);
           });
       </script>


    
    
  </head>
  
  <!-- default margin = default layout -->
  <body style="margin: 0 12%;">
    <a name="top"></a>
    
    <div class="container">
      
      <?php require_once 'helpers/helpers.php'; print_header();?>

      
      <div class="stripes"><span></span></div>
      
      <div class="nav">
	<?php
    	   require_once 'helpers/helpers.php';
	   print_menu();
	   ?>

	<div class="clearer"><span></span></div>
      </div>
      
      <div class="stripes"><span></span></div>
      
      <div class="main">
	
	<div class="left">
	  
	  <div class="content" id="clusterstatus">
	    <?php
	       require_once 'helpers/helpers.php';
	       require_once 'helpers/helpers_setup.php';
	       require_once 'helpers/helpers_cluster.php';
	       require_once 'helpers/helpers_backup.php';
	       if(check_db_config())
	       {
	       $action=isset($_GET["action"]) ? $_GET["action"] : '';
	       $id=isset($_GET["id"]) ? $_GET["id"] : 0;
	       print("<div class=\"detail-box\">\n");
	       print("<h1>Monitored Clusters</h1>");
	       print_cluster_status($id, $action);
	       print("</div>\n");
	       print_cluster_details_html($id, $action);  	       
	       }
	       ?>
	    </div>
	    <?php
	       print("<div class=\"content\">");
	       $action=isset($_GET["action"]) ? $_GET["action"] : '';
	       $id=isset($_GET["id"]) ? $_GET["id"] : 0;
	       if($action=='' && $id==0)
	       {
	       print("<a name=\"updates\"></a>\n");
	       print("<div class=\"detail-box\">\n");
	       print("<h1>Updates and Information</h1>\n");
	       print("<p>If you haven't configured using <a href=\"http://www.severalnines.com/config/\">Severalnines' Configurator</a>, then try it out now. The best and easiest way to get a production ready MySQL Cluster.</p>\n");
	       print("<p>CMON is intented for monitoring and there are no plans for web enabled start/stop of nodes, Alerts in various forms (e.g email etc) are planned for next release when bugs and issues have been addressed in this version</p>\n");
	       print("</div>\n");
       	       print("<a name=\"blogs\"></a>\n");
	       print("<div class=\"detail-box\">\n");
	       print("<h1>Blogs on MySQL Cluster</h1>\n");
	       print("<script type=\"text/javascript\">\n");
	       print("document.write(\"<h4 class=black>Johans blog on MySQL Cluster (config, explanations, deployment, ndbapi etc):</h4>\");\n");
	       print("document.write(\"<div class=\\\"detail-box2\\\">\");\n");
	       print(" new rssdisplayer(\"msndiv\", \"http://johanandersson.blogspot.com/feeds/posts/default\", 3, \"date, snippet\");\n");
	       print("  document.write(\"</div>\");\n");
	       print("document.write(\"<h4 class=black>Andrew's blog on MySQL Cluster:</h4>\");\n");
	       print("document.write(\"<div class=\\\"detail-box2\\\">\");\n");
	       print(" new rssdisplayer(\"msndiv1\", \"http://www.clusterdb.com/feed/\", 3, \"date, snippet\");\n");
	       print("document.write(\"</div>\");\n");
	       print("document.write(\"<h4 class=black>Jonas' blog (development/engineering):</h4>\");\n");
	       print("document.write(\"<div class=\\\"detail-box2\\\">\");\n");
	       print("  new rssdisplayer(\"msndiv2\", \"http://jonasoreland.blogspot.com/feeds/posts/default\", 3, \"date, snippet\");\n");
	       print("  document.write(\"</div>\");\n");
	       print("document.write(\"<h4 class=black>Mikael's blog (cluster, mysql server, partitioning):</h4>\");\n");
	       print("document.write(\"<div class=\\\"detail-box2\\\">\");\n");
	       print("  new rssdisplayer(\"msndiv3\", \"http://mikaelronstrom.blogspot.com/feeds/posts/default\", 3, \"date, snippet\");\n");
	       print("  document.write(\"</div>\");\n");
	       print("</script>\n");
	       
	       print("</div><div class=\"clearer\"><span></span></div>\n");
               }
	   ?>
	  <div class="clearer"><span></span></div>

	  <div class="clearer"><span></span></div>
	</div>
	</div>
	
	<div class="right">	  
	  <div class="subnav">
	    <div class="clear2">&nbsp;</div>
	
	    <ul>
	      <?php
		 require_once 'helpers/helpers_cluster.php';
		 $action=isset($_GET["action"]) ? $_GET["action"] : '';
		 $id=isset($_GET["id"]) ? $_GET["id"] : 0;
		 if($id==0 && $action=="")
		 {
		 print_dashboard_menu();
		 }
		 else
		 {
		 print_cluster_menu($id, $action);
		 print("<br>");
		 if($id>0)
	      print_sql_menu($id, 0);
	      print("<br>");
		print_cluster_admin_menu($id);
		}
		?>
		
    	      </ul>
	      <div class="clearer"><span></span></div>
	    </div>
	    <div class="clearer"><span></span></div>
	
	<div class="clearer"><span></span></div>
      </div>
      
      <div class="footer">
	<div class="bottom">
	  <span class="left">&copy; 2009 <a href="http://www.severalnines.com" target="_blank">www.severalnines.com</a>. Valid <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a> &amp; <a href="http://validator.w3.org/check?uri=referer">XHTML</a>.</span>
	  
	  <div class="clearer"><span></span></div>
	  
	</div>
	
      </div>
      
    </div>
  </body>
  
</html>
