<!-- 
Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  
  <head>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
    <meta name="description" content="description"/>
    <meta name="keywords" content="keywords"/> 
    <meta name="author" content="author"/> 
    <link rel="stylesheet" type="text/css" href="default.css" media="screen"/>
    <title>cmon - cluster enterprise monitor</title>
    
    <SCRIPT TYPE="text/javascript">
      <!--
	  function popup(mylink, windowname)
	  {
	  if (! window.focus)return true;
	  var href;
	  if (typeof(mylink) == 'string')
	  href=mylink;
	  else
	  href=mylink.href;
	  window.open(href, windowname, 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0,width=700,height=300,left = 570,top = 350');
	  return false;
	  }
	  //-->
    </SCRIPT>

    
  </head>
  
  <!-- default margin = default layout -->
  <body style="margin: 0 12%;">
    <a name="top"></a>
    
    <div class="container">
      
      <?php require_once 'helpers/helpers.php'; print_header();?>
      <div class="stripes"><span></span></div>
      
      <div class="nav">
	<?php
    	   require_once 'helpers/helpers.php';
	   print_menu();
	   ?>
	<div class="clearer"><span></span></div>
      </div>
      
      <div class="stripes"><span></span></div>
      
      <div class="main">
	
	<div class="left">
	  
	  <div class="content">
	    <h1>TOOLS</h1>
	    <div class="detail-box">
   	      <a href="http://www.severalnines.com/config" target="_blank"><img src="img/configurator.png" align="left"></img></a>
	      <h2>configurator - production class cluster configurations</h2>
	      <p>Configurator allows you to generate a production class MySQL Cluster configuration, with scripts to manage your cluster. The scripts are implemented following the best practices for how to command and control the nodes in the Cluster. The installation scripts lets you install Cluster in minutes on X number of nodes.</p><p>
		Read more about <a href="http://www.severalnines.com/config" target=\"_blank\">Configurator</a> here!</p>
    	    </div>
	    <div class="detail-box">
   	      <a href="http://www.severalnines.com/sizer" target="_blank"><img src="img/capacity.png" align="left"></img></a>
	      <h2>sizer - capacity planning tool</h2>
	      <p>Sizer is a capacity planning tool that allows you scope hardware resources (RAM, DISK).</p>
	      <p>Read more about sizer and download it <a href="http://www.severalnines.com/sizer" target="_blank">here</a>!</p>
    	    </div>
	      
	    <div class="detail-box">
   	      <a href="http://www.severalnines.com/bencher" target="_blank">
		<img src="img/bench.png" align="left"></img>
	      </a>
	      <h2>bencher - benchmarking tool</h2>
	      <p>A simple, multithreaded benchmarking tool that makes it easy to benchmark requests. Both SQL and NDBAPI requests are easily benchmarked. It is also possible to generate a GNU PLOT file and graphs!</p>
	      <p>Read more about bencher and download it <a href="http://www.severalnines.com/bencher" target="_blank">here</a>!</p>
    	    </div>
	    
	    
	  </div>
	  
	  <div class="right">
	    
	    <div class="subnav">
	      <div class="clear2">&nbsp;</div>
	      <br />
	      <br /><br /><br />
	      <ul>
		
    	      </ul>
	      <h1>&nbsp;</h1>
	    </div>
	    
	  </div>
	    
	  <div class="clearer"><span></span></div>
	  
	</div>
      </div>
      <div class="footer">
	<div class="bottom">
	  
	  <span class="left">&copy; 2009 <a href="http://www.severalnines.com" target="_blank">www.severalnines.com</a>. Valid <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a> &amp; <a href="http://validator.w3.org/check?uri=referer">XHTML</a>.</span>
	  
	  <div class="clearer"><span></span>
	  </div>
	  
	</div>
	
      </div>
      
    </div>
  </body>
  
</html>

		
