<!-- 
Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  
  <head>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
    <meta name="description" content="description"/>
    <meta name="keywords" content="keywords"/> 
    <meta name="author" content="author"/> 
    <link rel="stylesheet" type="text/css" href="default.css" media="screen"/>
    <title>cmon - cluster enterprise monitor</title>
    <script type="text/javascript" src="rssdisplayer.js"></script>
    <script type="text/javascript" src="prototype.js"></script>
    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3/jquery.min.js"></script>
       <script type="text/javascript">
          var refresh=30000;
          $(function(){
	  document.$_GET = [];
	  var urlHalves = String(document.location).split('?');
	  if(urlHalves[1]){
	  var urlVars = urlHalves[1].split('&');
	  for(var i=0; i<=(urlVars.length); i++){
					    if(urlVars[i]){
					    var urlVarPair = urlVars[i].split('=');
					    document.$_GET[urlVarPair[0]] = urlVarPair[1];
					    }
					    }
					}
	     var doc="";
             if(document.$_GET['filter'] && document.$_GET['id'] && document.$_GET['offset'] && document.$_GET['event'])
                doc="$('#clusterlog').load(" + "'get_clusterlog.php?id=" + document.$_GET['id'] + "&offset="+ document.$_GET['offset']  + "&filer=" + document.$_GET['filter'] + "&event=" + document.$_GET['event'] +"');";
	     else
                doc="$('#clusterlog').load(" + "'get_clusterlog.php');";

             setInterval(doc,refresh);
           });
       </script>

    



  </head>

  <!-- default margin = default layout -->
  <body style="margin: 0 12%;">
    <a name="top"></a>

    <div class="container">
      <?php require_once 'helpers/helpers.php'; print_header();?>

      <div class="stripes"><span></span></div>
      
      <div class="nav">
	<?php
    	   require_once 'helpers/helpers.php';
	   print_menu();
	   ?>
	<div class="clearer"><span></span></div>
      </div>

      <div class="stripes"><span></span></div>

      <div class="main">
	
	<div class="left">

	  <div class="content" id="clusterlog">
	    <h1>Monitored Clusters</h1>
	    <?php
	       require_once 'helpers/helpers.php';
	       require_once 'helpers/helpers_cluster.php';
	       require_once 'helpers/helpers_backup.php';

               $action=isset($_GET["action"]) ? $_GET["action"] : '';
               $id=isset($_GET["id"]) ? $_GET["id"] : 0;
               print_cluster_status($id, $action);
               print("<hr>\n");
	       $offset = isset($_GET['offset']) ? $_GET['offset']: '0';
               $filter = isset($_GET['filter']) ? $_GET['filter']: '';
               $event = isset($_GET['event']) ? $_GET['event']: '';
	       print_cluster_log_html($id, $offset, $filter, $event);
               ?>

          </div>

	</div>

	<div class="right">

          <div class="subnav">
            <div class="clear2">&nbsp;</div>
            <br />
            <br /><br /><br />
	    <ul>
              <?php
		 $action=isset($_GET["action"]) ? $_GET["action"] : '';
		 $id=isset($_GET["id"]) ? $_GET["id"] : 0;
		 print_cluster_menu($id, $action);
 	       print("<br />");
		 print_sql_menu($id,0);
		 print("<br />");
	       print_cluster_admin_menu($id);  
		 ?>

    	    </ul>
	    <h1>&nbsp;</h1>
	  </div>

	</div>

	<div class="clearer"><span></span></div>

      </div>

      <div class="footer">
	<div class="bottom">
	  
	  <span class="left">&copy; 2009 <a href="http://www.severalnines.com" target="_blank">www.severalnines.com</a>. Valid <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a> &amp; <a href="http://validator.w3.org/check?uri=referer">XHTML</a>.</span>
	  
	  <div class="clearer"><span></span></div>
	  
	</div>
	
      </div>
      
    </div>
  </body>
  
</html>
