<?php
/* Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

function get_traffic_light($status, $warning)	
{
   if($warning==1)
      return "yellow";

   if(strcmp($status,"NO_CONTACT")==0)
   {
	return "red";
   }

   if(strcmp($status,"DEGRADED")==0)
   {
	return "yellow";
   }



   if(strcmp($status,"RECOVERING")==0)
   {
	return "yellow";
   }

   if(strcmp($status,"UNKNOWN")==0)
   {
	return "red";
   }

   if(strcmp($status,"STARTED")==0)
   {
	return "green";
   }

   if(strcmp($status,"ALERT")==0)
   {
	return "red";
   }


   if(strcmp($status,"ERROR")==0)
   {
	return "red";
   }


   if(strcmp($status,"INFO")==0)
   {
	return "green";
   }

   if($status==0)
   {
	return "red";
   }

   if($status==1)
   {
	return "green";
   }

   return "yellow";
}


 function sec2dhms ($sec, $h_padding = false) 
  {

    $dhms = "";
    $hours = intval(intval($sec) / 3600); 
    $days= intval(intval($hours)/24);
    $hours=$hours - (24 * $days);
    
    $dhms = str_pad($days, 2, "0", STR_PAD_LEFT). ' days ';

    $dhms .= ($h_padding) 
          ? str_pad($hours, 2, "0", STR_PAD_LEFT). ' hours '
          : $hours. ' hours ';    

    $minutes = intval(($sec / 60) % 60); 

    $dhms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ' minutes and ';


    $seconds = intval($sec % 60); 

    $dhms .= str_pad($seconds, 2, "0", STR_PAD_LEFT) . ' seconds ';

    return $dhms;
    
  }


?>