<?php
/* Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

function check_db_config()
{  
   $file="config/config_db1.php";
   if(file_exists($file))
   {
     return true;
   } else
   {
     print("<h4>You must run the <a href=\"setup.php\">setup</a> first!</h4>");
     return false;
   }
}

function print_setup_html()
{
        print("<h2>Primary connection</h2>");
	print ("<form action=\"setup.php\" method=\"get\">\n");
	print("<table>\n");
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\">hostname<br>(hostname where 'cmon' mysql server is located)</td>");
	print ("<td><span style=\"width: 90%;\">");
	print ("<input name=\"hostname\" style=\"width: 90%;\" type=\"text\" id=\"hostname\" tabindex=\"1\"  maxlength=\"255\" /></span></td>");
	print ("</tr>");
	print ("<tr>");
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\">port</td>");
	print ("<td><span style=\"width: 90%;\">");
	print ("<input name=\"port\" style=\"width: 90%;\" type=\"text\" id=\"port\"  tabindex=\"1\"   maxlength=\"255\" /></style></td>");
	print ("</tr>");
	/*print ("<tr>");	
	print ("<td width=\"30%\" class=\"hed\">socket <br>(optional, if you are on 'localhost')</td>");
	print ("<td><span style=\"width: 90%;\">");
	print ("<input name=\"socket\" style=\"width: 90%;\" type=\"text\" id=\"socket\"  tabindex=\"1\"   maxlength=\"255\" /></style></td>");
	print ("</tr>");*/
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\">user name<br/>(to connect to mysql server holding 'cmon' db</td>");
	print ("<td>");
	print ("<input name=\"username\"  style=\"width: 90%;\" type=\"text\" id=\"username\"  tabindex=\"1\"  maxlength=\"255\" /></td>");
	print ("</tr>");
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\" align=\"left\">password</td>");
	print ("<td>");
	print ("<input name=\"password\" style=\"width: 90%;\" type=\"text\" id=\"password\"  tabindex=\"1\"  maxlength=\"255\" /></td>");
	print ("</tr>");
	print ("</table>");
        print("<h2>Secondary connection</h2> <h4>(optional - only if you have two CMONs monitoring one Cluster)</h4>");
        print("<p>If the primary mysql server holding the cmon data base is down, then it is possible to failover to the secondary, provided the secondary also has a cmon agent running.</p>");
	print("<table>\n");
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\">hostname<br>(hostname where 'cmon' mysql server is located)</td>");
	print ("<td><span style=\"width: 90%;\">");
	print ("<input name=\"hostname2\" style=\"width: 90%;\" type=\"text\" id=\"hostname2\" tabindex=\"1\"  maxlength=\"255\" /></span></td>");
	print ("</tr>");
	print ("<tr>");
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\">port</td>");
	print ("<td><span style=\"width: 90%;\">");
	print ("<input name=\"port2\" style=\"width: 90%;\" type=\"text\" id=\"port2\"  tabindex=\"1\"   maxlength=\"255\" /></style></td>");
	print ("</tr>");
/*
	print ("<tr>");	
	print ("<td width=\"30%\" class=\"hed\">socket <br>(optional, if you are on 'localhost')</td>");
	print ("<td><span style=\"width: 90%;\">");
	print ("<input name=\"socket2\" style=\"width: 90%;\" type=\"text\" id=\"socket2\"  tabindex=\"1\"   maxlength=\"255\" /></style></td>");
	print ("</tr>");
*/
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\">user name<br/>(to connect to mysql server holding 'cmon' db</td>");
	print ("<td>");
	print ("<input name=\"username2\"  style=\"width: 90%;\" type=\"text\" id=\"username2\"  tabindex=\"1\"  maxlength=\"255\" /></td>");
	print ("</tr>");
	print ("<tr>");
	print ("<td width=\"30%\" class=\"hed\" align=\"left\">password</td>");
	print ("<td>");
	print ("<input name=\"password2\" style=\"width: 90%;\" type=\"text\" id=\"password2\"  tabindex=\"1\"  maxlength=\"255\" /></td>");
	print ("</tr>");
	print ("</table><br><br>");
	print ("<input tabindex=\"2\" name=\"submit\" type=\"submit\" value=\"Test the connection and contiune\"/>");
	print ("</form>");


}
function print_test_connection_html($user, $pass, $host, $port, $socket, $type)
{
  if($user=="" || $host=="")
 {
     if($type=="Primary") 
     {
        print("<h4>" . $type . " connection - insufficient parameters</h4>");
        print("<p>You must specify atleast 'hostname' and 'username'.</p>");
        print("<a href=\"setup.php\">Go back and try again</a>.");
	die();
     } else
     {
        print("<h4>" . $type . " connection - not defined.</h4>");
	/**
	write config anyways so it can be changed (manually) later.
          */
        write_config($user, $pass, $host, $port, $socket, $type);
 	 print("<p>Wrote empty 'config/config_db2.php'<br>You can only change this file manually if you need to.</p>");
        print("<a href=\"index.php\">Reload the page to finish the setup!</a>.");
	die();
     }
 }
     

  if(test_conn($user, $pass, $host, $port, $socket))
  {
         print("<h4>" . $type . " connection successful!</h4>");
	 if($type=="Primary")
   	    print("<p>Writing configuration data to 'config/config_db1.php'<br>You can only change this file manually if you need to.</p>");
	 else
   	    print("<p>Writing configuration data to 'config/config_db2.php'<br>You can only change this file manually if you need to.</p>");
	 write_config($user, $pass, $host, $port, $socket, $type);
  }
  else
  {
     print("<h4>" . $type . " connection failed to connect to mysql server at</h4>");
     print("<p>");
     print("Hostname=$host<br>");
     print("Port=$port<br>");
     print("Socket=$socket<br>");
     print("User name=$user<br>");
     print("Password=$pass<br>");
     print("</p>");
     print("<a href=\"index.php\">Go back and try again</a>.");
     die();
  }
}

function test_conn($user, $pass, $hostname, $port, $socket)
{
  $host="";
  if($socket!="" && (strcmp($hostname,"localhost")==0))
    $host=":" . $socket;
  else
  {
    if($port==0 || $port=="")
       $port=3306;
     $host=$hostname . ":" . $port;
  }

  $dbh = mysql_connect($host, 
		       $user, 
		       $pass);
  if(!$dbh)
  {
    return false;
  }
  mysql_close($dbh);
  return true;
}

function write_config($user, $pass, $host, $port, $socket, $type)
{   
    $id=1;
    if($type=="Primary")
      $id=1;
    else
      $id=2;
    if($port=="" || $port==0)
       $port=3306;

    $file="config/config_db" . $id . ".php";
    $fp = fopen($file, "w"); // || die("Couln't open $file");
    fwrite($fp, "<?php\n");
    fwrite($fp, "\$DB_HOSTNAME" . $id .  "=\"$host\";\n");
    fwrite($fp, "\$DB_PORT" . $id .  "=$port;\n");
    fwrite($fp, "\$DB_SOCKET" . $id .  "=\"$socket\";\n");
    fwrite($fp, "\$DB_USERNAME" . $id .  "=\"$user\";\n");
    fwrite($fp, "\$DB_PASSWORD" . $id .  "=\"$pass\";\n");
    fwrite($fp, "\$DB_DB=\"cmon\";\n");
    fwrite($fp, "?>");
    fclose($fp);    
}
?>
