<!-- 
Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

  <head>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
    <meta name="description" content="description"/>
    <meta name="keywords" content="keywords"/> 
    <meta name="author" content="author"/> 
    <link rel="stylesheet" type="text/css" href="default.css" media="screen"/>
    <title>cmon - cluster enterprise monitor</title>

    <SCRIPT TYPE="text/javascript">
      <!--
	  function popup(mylink, windowname)
	  {
	  if (! window.focus)return true;
	  var href;
	  if (typeof(mylink) == 'string')
	  href=mylink;
	  else
	  href=mylink.href;
	  window.open(href, windowname, 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0,width=700,height=300,left = 570,top = 350');
	  return false;
	  }
	  //-->
    </SCRIPT>


  </head>

  <!-- default margin = default layout -->
  <body style="margin: 0 12%;">
    <a name="top"></a>

    <div class="container">

      <?php require_once 'helpers/helpers.php'; print_header();?>
      
      <div class="stripes"><span></span></div>
      
      <div class="nav">
	<?php
    	   require_once 'helpers/helpers.php';
	   print_menu();
	   ?>
	<div class="clearer"><span></span></div>
      </div>
      
      <div class="stripes"><span></span></div>
      
      <div class="main">
	
	<div class="left">
	  
	  <div class="content">
	    <h1>LIBRARY</h1>
	    <div class="detail-box"
		 <h2>Reference manual</h2>
		 <ul>
		   <li><a href="http://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-params-ndbd.html">NDBD configuration parameters</a></li>
		   <li><a href="http://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-params-api.html">API/MYSQLD configuration parameters</a></li>
		   <li><a href="http://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-params-ndbd.html">NDB_MGMD configuration parameters</a></li>
		   <li><a href="http://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-replication.html">Replication</a></li>
		   <li><a href="http://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html">MYSQL variables</a></li>
		 </ul>
    	  </div>
				   
	  <div class="detail-box"
	       <h2>Blog posts</h2>
	       <ul>
		 <li><a href="http://johanandersson.blogspot.com/2009/05/cluster-fails-to-start-self-diagnosis.html">Self diagnosis of MySQL Cluster</a></li>
		 <li><a href="http://www.clusterdb.com/mysql-cluster/mysql-cluster-fault-tolerance-impact-of-deployment-decisions/">Deployment scenarios and consequences</a></li>			    
		 <li><a href="http://johanandersson.blogspot.com/2008/12/disk-data-summary.html">Disk data - a summary</a></li>
		 <li><a href="http://johanandersson.blogspot.com/2009/05/ha-mysql-write-scaling-using-cluster-to.html">HA MySQL using MySQL Cluster</a></li>
		 <li><a href="http://johanandersson.blogspot.com/2009/04/maxrows-in-cluster.html">If you have more than 90M records..</a></li>
		 <li><a href="http://johanandersson.blogspot.com/2007/10/memory-allocation-and-deallocation-in.html">Memory - allocation and deallocation</a></li>
		 <li><a href="http://johanandersson.blogspot.com/2008/11/disk-data-extent-deallocation-caveats.html">Disk data - extent allocation and deallocation</a></li>			    
		 <li><a href="http://www.clusterdb.com/mysql-cluster/mysql-cluster-data-node-restart-times/">Node restart times</a></li>			    
		 <li><a href="http://www.clusterdb.com/mysql-cluster/setting-up-mysql-asynchronous-replication-for-high-availability/">Asynchronous replication</a></li>			    
		 <li><a href="http://johanandersson.blogspot.com/2009/03/online-add-node-preliminary-numbers.html">Online add node</a></li>			    
	       </ul>
	       
	</div>
	
	
      </div>
      
    </div>
    
    <div class="right">
      
      <div class="subnav">
	<div class="clear2">&nbsp;</div>
	<br />
	<br /><br /><br />
	<ul>
	  
	</ul>
	<h1>&nbsp;</h1>
      </div>
      
    </div>
    
    <div class="clearer"><span></span></div>
    
    
    
    <div class="footer">
      
      
      
      <div class="bottom">
	
	<span class="left">&copy; 2009 <a href="http://www.severalnines.com" target="_blank">www.severalnines.com</a>. Valid <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a> &amp; <a href="http://validator.w3.org/check?uri=referer">XHTML</a>.</span>
	
	<div class="clearer"><span></span></div>
	
      </div>
      
    </div>
    
  </body>
  
</html>
