<!-- 
Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  
  <head>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
    <meta name="description" content="description"/>
    <meta name="keywords" content="keywords"/> 
    <meta name="author" content="author"/> 
    <link rel="stylesheet" type="text/css" href="default.css" media="screen"/>
    <title>cmon - cluster enterprise monitor</title>
    
    
    
    <script type="text/javascript" src="rssdisplayer.js"></script>
    <script type="text/javascript" src="prototype.js"></script>
    
    
  </head>

  <!-- default margin = default layout -->
  <body style="margin: 0 12%;">
    <a name="top"></a>
    
    <div class="container">
      <?php require_once 'helpers/helpers.php'; print_header();?>

      
      <div class="stripes"><span></span></div>
      
      <div class="nav"
	   <?php
    	      require_once 'helpers/helpers.php';
	      print_menu();
	      ?>
	   <div class="clearer"><span></span></div>
      </div>
    
    <div class="stripes"><span></span></div>
    
    <div class="main">
      
      <div class="left">
	
	<div class="content">
	  
	  <?php
              print("<h1>Setup connection to 'cmon' database</h1>");
	      require_once('helpers/helpers_setup.php'); 
	      $host=isset($_GET["hostname"]) ? $_GET["hostname"] : "";
	      $user=isset($_GET["username"]) ? $_GET["username"] : "";
	      $pass=isset($_GET["password"]) ? $_GET["password"] : "";
	      $socket=isset($_GET["socket"]) ? $_GET["socket"] : "";
	      $port=isset($_GET["port"]) ? $_GET["port"] : 0;
	      if($host=="" && $user=="")
		{
		  print_setup_html();
		  
		} else
		{
		  $host2=isset($_GET["hostname2"]) ? $_GET["hostname2"] : "";
		  $user2=isset($_GET["username2"]) ? $_GET["username2"] : "";
		  $pass2=isset($_GET["password2"]) ? $_GET["password2"] : "";
		  $socket2=isset($_GET["socket2"]) ? $_GET["socket2"] : "";
		  $port2=isset($_GET["port2"]) ? $_GET["port2"] : 0;
		  
		  print_test_connection_html($user, $pass, $host, $port, $socket, "Primary");
		  print_test_connection_html($user2, $pass2, $host2, $port2, $socket2, "Secondary");
		}
	     
             
             ?>
	</div>
	
      </div>
      
      <div class="right">
	
        <div class="subnav">
          <div class="clear2">&nbsp;</div>
          <br />
          <br /><br /><br />
	  <ul>
	    
    	  </ul>
	  <h1>&nbsp;</h1>
	</div>
	
      </div>
      
      <div class="clearer"><span></span></div>
      
    </div>
    
    <div class="footer">
      
      
      
      <div class="bottom">
	
	<span class="left">&copy; 2009 <a href="http://www.severalnines.com" target="_blank">www.severalnines.com</a>. Valid <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a> &amp; <a href="http://validator.w3.org/check?uri=referer">XHTML</a>.</span>
	
	<div class="clearer"><span></span></div>
	
      </div>
      
    </div>
    
  </body>
  
</html>
